Attribute VB_Name = "MainModLINRS232"
Option Explicit
'Global quicker As Boolean '1.6
Global ReceiveBufferOverflowOccurred(16) As Boolean '2.0.6
Global ClearBufferOccurred(16) As Boolean '2.0.6
Global ClearBufferTimestamp(16) As Integer '2.0.6
Global wakeupenabled As Boolean '1.6
Global logging As Boolean
Global logfilesize As Long
Global inAddText As Boolean
Global ErrorCode As Integer
Global Ack_Received As Byte
Global RecvGot As Integer
Global GotMismatch As Boolean
Global MismatchError As Boolean
Global RecvError As Boolean
Global Repeat_ID As Integer
Global Repeat_ID2 As Integer
Global BadChecksum As Boolean
Global NoResponse As Boolean '1.2
Global Repeat2 As Boolean '1.2
Global Waiting As Boolean
Global LIN20 As Boolean '2.0
Global ExtendedWakeup As Boolean
Global sStr As String
Global BaudRate As Long
Global WakeupMode As Boolean
Global SlaveMode As Boolean
Global Message As String
Global HexNum As Integer
Global TimeVal As Integer
Global Quit As Boolean
Global Loaded As Boolean
Global SendSettings As Boolean
Global SelectedNode As Integer
Global Selected_Message As Integer
Global Number_of_Messages As Integer
Global Number_of_Ports As Integer
Global PortNum(50) As Integer
Global in_background As Boolean
Global RecvMismatchInit(16) As Boolean
Global RecvExpected(16) As Integer
Global swallowcount(16) As Integer
Global recvstr(16) As String
Global recvstate(16) As Integer
Global recvcks(16) As Integer
Global recvID(16) As Integer
Global recvdatastr(16) As String
Global datafield1(16) As Integer
Global datafield2(16) As Integer
Global datafield3(16) As Integer
Global datafield4(16) As Integer
Global HundredMsec As Integer
Global PendingAck As Integer
Global WaitPendingAck As Boolean
Global FastInterval As Integer

Global Const MAX_BAUD = 20000
Global Const MIN_BAUD = 1000

Global Const MAX_FAST_INTERVAL = 5000
Global Const MIN_FAST_INTERVAL = 0

Global Const CLEAR_RECEIVE_BUFFER = &H81
Global Const SEND_WAKEUP_SIGNAL = &H82
Global Const QUERY_STATUS = &H83
Global Const QUERY_REVISION = &H84

Global Const SET_WAKEUP_PENDING = &H91
Global Const SET_LIN_BUS_BAUD_RATE = &H92
Global Const SET_WAKEUPS_ENABLED = &H93
Global Const SET_LIN_PROTOCOL = &H94 '2.0
Global Const SET_EXTENDED_WAKEUP = &H95
Global Const SET_MASTER_SLAVE_MODE = &H96
Global Const SET_FAST_REPEAT_INTERVAL = &H97
Global Const SET_FAST_REPEAT_MODE = &H98
Global Const PASSWORD = 0 'unused

Public Sub SaveData()
Dim i As Integer
On Error GoTo writeerror
Open App.Path + "\LIN.CFG" For Output As #1
On Error GoTo writeerror2
Print #1, Format(SelectedNode, "#0")
Print #1, Format(Selected_Message, "#0")
Print #1, Format(BaudRate, "#0")
If BadChecksum = True Then
    Print #1, "1"
Else
    Print #1, "0"
End If
If WakeupMode = True Then
    Print #1, "1"
Else
    Print #1, "0"
End If
If NoResponse = True Then
    Print #1, "1"
Else
    Print #1, "0"
End If
If Repeat2 = True Then
    Print #1, "1"
Else
    Print #1, "0"
End If
Print #1, Format(Number_of_Ports, "#0")
For i = 1 To Number_of_Ports
    Print #1, PortNum(i - 1)
Next i
If MismatchError = True Then
    Print #1, "1"
Else
    Print #1, "0"
End If
If RecvError = True Then
    Print #1, "1"
Else
    Print #1, "0"
End If
'If quicker = True Then
'    Print #1, "1"
'Else
'    Print #1, "0"
'End If
If wakeupenabled = True Then
    Print #1, "1"
Else
    Print #1, "0"
End If
If LIN20 = True Then
    Print #1, "1"
Else
    Print #1, "0"
End If
If ExtendedWakeup = True Then
    Print #1, "1"
Else
    Print #1, "0"
End If
If SlaveMode = True Then
    Print #1, "1"
Else
    Print #1, "0"
End If
Print #1, Format(FastInterval, "#0")
Close #1
Exit Sub
writeerror:
On Error Resume Next
MsgBox "Error opening LIN.CFG for writing!"
Exit Sub
writeerror2:
On Error Resume Next
MsgBox "Error writing to LIN.CFG!"
Close #1
End Sub
Public Function Hexx(ByVal Value As Integer) As String
Dim HexStr As String
HexStr = Hex$(Value)
While Len(HexStr) < 2
    HexStr = "0" + HexStr
Wend
Hexx = HexStr
End Function
Public Sub RecvBackgroundTask()
Dim i As Integer
  If in_background = True Then
    Exit Sub
End If
in_background = True
On Error GoTo comportclosed
    For i = 1 To Number_of_Ports
        If fTop.comPort(i - 1).InBufferCount = fTop.comPort(i - 1).InBufferSize Then
            Add_Text PortNum(i - 1), "PC Receive Buffer Overflow!"
            ReceiveBufferOverflowOccurred(i - 1) = True
            fTop.comPort(i - 1).PortOpen = False
            fTop.comPort(i - 1).PortOpen = True
        End If
        If Len(recvstr(i - 1)) > 0 Then
            If swallowcount(i - 1) > 0 Then
                swallowcount(i - 1) = swallowcount(i - 1) - 1
            Else
                Handle_Recv i, Asc(Left$(recvstr(i - 1), 1))
            End If
            If Len(recvstr(i - 1)) > 1 Then
                recvstr(i - 1) = Right$(recvstr(i - 1), Len(recvstr(i - 1)) - 1)
            Else
                recvstr(i - 1) = ""
            End If
        Else
            ReceiveBufferOverflowOccurred(i - 1) = False
            If (ClearBufferOccurred(i - 1) = True) Then
                If (Elapsed(ClearBufferTimestamp(i - 1)) > 20) Then
                    ClearBufferOccurred(i - 1) = False
                End If
            End If
        End If
    Next i
in_background = False
On Error Resume Next
Exit Sub
comportclosed:
On Error Resume Next
Add_Text PortNum(i - 1), "Trouble accessing COM port."
End Sub

Public Sub Main()
Dim i As Integer
Quit = False
For i = 0 To 15
    ReceiveBufferOverflowOccurred(i) = False
    ClearBufferOccurred(i) = False
Next i
fTop.Show
While Quit = False
    DoEvents
    RecvBackgroundTask
Wend
End
End Sub
Private Sub Handle_Recv(i As Integer, RecvChar As Integer)
Dim j As Integer
Dim lincks As Integer
If (recvstate(i - 1) And 128) = 0 Then
    'header not received yet
    If RecvChar = Asc(Mid$("RESP:", recvstate(i - 1) + 1, 1)) Then
goth:   Update_Cks i, RecvChar
        If recvstate(i - 1) >= 4 Then
            recvstate(i - 1) = 128
        Else
            recvstate(i - 1) = recvstate(i - 1) + 1
        End If
    Else
        recvstate(i - 1) = 0
        recvcks(i - 1) = 0
        If RecvChar = Asc("R") Then
            GoTo goth
        Else
            If RecvChar > 0 Then '1.5 0 is okay if buffer overflowed
                Add_Text PortNum(i - 1), "RX: BAD CHAR " + Hexx(RecvChar) + " (" + Chr$(RecvChar) + ")!"
                If ReceiveBufferOverflowOccurred(i - 1) = True Then
                    Add_Text PortNum(i - 1), "(BUT THAT IS PROBABLY BECAUSE THE SERIAL RECEIVE BUFFER OVERFLOWED)"
                End If
                If ClearBufferOccurred(i - 1) = True Then
                    Add_Text PortNum(i - 1), "(BUT THAT IS BECAUSE CLEAR BUFFERS OPERATION IS IN EFFECT AND BUFFER MAY HAVE BEEN CLEARED IN MIDDLE)"
                End If
            End If
            If RecvError = True Then
                StopRepeat
            End If
        End If
    End If
Else
    'header received
    Select Case (recvstate(i - 1) And 127)
        Case 0: 'Recv ID
            recvID(i - 1) = RecvChar
            Update_Cks i, RecvChar
            Select Case RecvChar
                Case &H81:
                    recvstate(i - 1) = 128 + 1
                Case &H82:
                    recvstate(i - 1) = 128 + 2
                Case Else:
                    If RecvChar And &HC0 Then
                        Add_Text PortNum(i - 1), "RX: ILLEGAL ID " + Hex$(RecvChar)
                        If RecvError = True Then
                            StopRepeat
                        End If
                        recvstate(i - 1) = 0
                        recvcks(i - 1) = 0
                    Else
                        recvdatastr(i - 1) = Chr$(RecvChar)
                        recvstate(i - 1) = 128 + 7
                    End If
            End Select
        Case 1: 'Recv Revision Level
            Update_Cks i, RecvChar
            recvdatastr(i - 1) = Chr$(RecvChar)
            recvstate(i - 1) = 128 + 5
        Case 2: 'Recv Status Code
            Update_Cks i, RecvChar
            recvdatastr(i - 1) = Chr$(RecvChar)
            recvstate(i - 1) = 128 + 3
        Case 3: 'Recv Bus Awake
            Update_Cks i, RecvChar
            recvdatastr(i - 1) = recvdatastr(i - 1) + Chr$(RecvChar)
            recvstate(i - 1) = 128 + 4
        Case 4: 'receive command ack
            Update_Cks i, RecvChar
            recvdatastr(i - 1) = recvdatastr(i - 1) + Chr$(RecvChar)
            recvstate(i - 1) = 128 + 5
        Case 5: 'Recv checksum #1
            If recvcks(i - 1) = RecvChar Then
                recvstate(i - 1) = 128 + 6
            Else
                If RecvChar Then '1.5: a 0 checksum happens when buffer overflows
                    Add_Text PortNum(i - 1), "RX: Bad checksum #1 from LIN Converter Box"
                End If
                If RecvError = True Then
                    StopRepeat
                End If
                recvstate(i - 1) = 0
                recvcks(i - 1) = 0
            End If
        Case 6: 'Recv checksum #2
            If (255 - recvcks(i - 1)) = RecvChar Then
                If (recvID(i - 1) And (128 + 64)) = 0 Then
                    sStr = ""
                    lincks = 0
                    For j = 2 To (Len(recvdatastr(i - 1)) - 1)
                        lincks = lincks + Asc(Mid$(recvdatastr(i - 1), j, 1))
                        If lincks >= 256 Then lincks = lincks - 255
                    Next j
                    lincks = 255 - lincks
                    GotMismatch = False
                    For j = 1 To (Len(recvdatastr(i - 1)) - 1)
                        RecvGot = Asc(Mid$(recvdatastr(i - 1), j, 1))
                        If RecvMismatchInit(i - 1) = False Then
                            RecvExpected(i - 1) = RecvGot
                            RecvMismatchInit(i - 1) = True
                        Else
                            RecvExpected(i - 1) = RecvExpected(i - 1) + 1
                            If RecvExpected(i - 1) > &H3F Then
                                RecvExpected(i - 1) = 0
                            End If
                            If RecvGot <> RecvExpected(i - 1) Then
                                GotMismatch = True
                            End If
                        End If
                        sStr = sStr + Hexx(Asc(Mid$(recvdatastr(i - 1), j, 1))) + " "
                    Next j
                    lincks = 0
                    For j = 2 To (Len(recvdatastr(i - 1)) - 1)
                        lincks = lincks + Asc(Mid$(recvdatastr(i - 1), j, 1))
                        If lincks >= 256 Then lincks = lincks - 255
                    Next j
                    lincks = 255 - lincks
                    If lincks = Asc(Right$(recvdatastr(i - 1), 1)) Then
                        sStr = sStr + "LIN 1.3 CKS OK"
                    Else
                        lincks = recvID(i - 1) Or &H80
                        If ((lincks And 1) = 1) Then lincks = lincks Xor &H40
                        If ((lincks And 2) = 2) Then lincks = lincks Xor &HC0
                        If ((lincks And 4) = 4) Then lincks = lincks Xor &H40
                        If ((lincks And 8) = 8) Then lincks = lincks Xor &H80
                        If ((lincks And &H10) = &H10) Then lincks = lincks Xor &HC0
                        If ((lincks And &H20) = &H20) Then lincks = lincks Xor &H80
                        For j = 2 To (Len(recvdatastr(i - 1)) - 1)
                            lincks = lincks + Asc(Mid$(recvdatastr(i - 1), j, 1))
                            If lincks >= 256 Then lincks = lincks - 255
                        Next j
                        lincks = 255 - lincks
                        If lincks = Asc(Right$(recvdatastr(i - 1), 1)) Then
                            sStr = sStr + "LIN 2.0 CKS OK"
                        Else
                            If Len(recvdatastr(i - 1)) >= 2 Then
                                sStr = sStr + "LIN CKS BAD"
                            Else
                                sStr = Hexx(recvID(i - 1)) + " SLAVE NOT RESPONDING"
                            End If
                            If BadChecksum = True Or RecvError = True Then
                                StopRepeat
                            End If
                        End If
                    End If
                    Add_Text PortNum(i - 1), "RX: " + sStr
                    If GotMismatch = True And MismatchError = True Then
                        Add_Text fTop.comPort(i - 1), "RX: Mismatch Error"
                        RecvMismatchInit(i - 1) = False
                        If RecvError = True Then
                            StopRepeat
                        End If
                    End If
                Else
                    If recvID(i - 1) = &H81 Then
                        Add_Text PortNum(i - 1), "RX: Revision Level" + Str$(Asc(recvdatastr(i - 1)))
                        Ack_Received = QUERY_REVISION
                    Else
                        If recvID(i - 1) = &H82 Then
                            Ack_Received = Asc(Right$(recvdatastr(i - 1), 1))
                            ErrorCode = Asc(Left$(recvdatastr(i - 1), 1))
                            If ErrorCode = &H4F Then
                                Select Case Asc(Right$(recvdatastr(i - 1), 1)):
                                    Case &H81: Add_Text PortNum(i - 1), "RX: Ack Clear Receive Buffer; Buffer Cleared"
                                    Case &H82: Add_Text PortNum(i - 1), "RX: Ack Send Wake-Up Signal; Wake-Up Sent"
                                    Case &H83: Add_Text PortNum(i - 1), "RX: Ack Query Status; LIN Box is Okay"
                                    Case &H91: Add_Text PortNum(i - 1), "RX: Ack Set Wake-Up Pending"
                                    Case &H92: Add_Text PortNum(i - 1), "RX: Ack Set LIN Bus Baud Rate"
                                    Case &H93: Add_Text PortNum(i - 1), "RX: Ack Set Wake-Up Enable"
                                    Case &H94: Add_Text PortNum(i - 1), "RX: Ack Set LIN Protocol"
                                    Case &H95: Add_Text PortNum(i - 1), "RX: Ack Set Extended Wakeups"
                                    Case &H96: Add_Text PortNum(i - 1), "RX: Ack Set Master/Slave Mode"
                                    Case &H97: Add_Text PortNum(i - 1), "RX: Ack Set Fast Repeat Interval"
                                    Case &H98: Add_Text PortNum(i - 1), "RX: Ack Set Fast Repeat Mode"
                                    Case Else:
                                        If Asc(Right$(recvdatastr(i - 1), 1)) < &H40 Then
                                            Add_Text PortNum(i - 1), "Ack Message " + Hex$(Asc(Right$(recvdatastr(i - 1), 1))) + "; LIN Box is Okay"
                                            If WaitPendingAck = True Then
                                                If PendingAck = Asc(Right$(recvdatastr(i - 1), 1)) Then
                                                    WaitPendingAck = False
                                                End If
                                            End If
                                        Else
                                            Add_Text PortNum(i - 1), "Ack Unknown Command " + Hex$(Asc(Right$(recvdatastr(i - 1), 1))) + "; LIN Box is Okay"
                                        End If
                                End Select
                            Else
                                DisplayErrorCode i - 1
                                If ErrorCode = 6 And NoResponse = True Then
                                    StopRepeat
                                End If
                                If RecvError = True Then
                                    StopRepeat
                                End If
                            End If
                            'If Asc(Right$(recvdatastr(i - 1), 1)) = 0 Then
                            '    Add_Text PortNum(i - 1), "RX: Bus was asleep."
                            'Else
                            '    Add_Text PortNum(i - 1), "RX: Bus was awake."
                            'End If
                        End If
                    End If
                End If
            Else
                Add_Text PortNum(i - 1), "RX: Bad checksum #2 from LIN Converter Box"
                If RecvError = True Then
                    StopRepeat
                End If
            End If
            recvstate(i - 1) = 0
            recvcks(i - 1) = 0
        Case 7: 'recv data #1
            Update_Cks i, RecvChar
            datafield1(i - 1) = RecvChar
            recvstate(i - 1) = 128 + 8
        Case 8: 'recv data #2
            Update_Cks i, RecvChar
            datafield2(i - 1) = RecvChar
            recvstate(i - 1) = 128 + 9
        Case 9: 'recv data #3
            Update_Cks i, RecvChar
            datafield3(i - 1) = RecvChar
            recvstate(i - 1) = 128 + 10
        Case 10: 'recv data #4
            Update_Cks i, RecvChar
            datafield4(i - 1) = RecvChar
            recvstate(i - 1) = 128 + 11
        Case 11: 'recv length/continuation indicator
            Update_Cks i, RecvChar
            Select Case RecvChar
                Case 0: 'end of message
                    recvstate(i - 1) = 128 + 5
                Case 1: '1 byte and end of message
                    recvdatastr(i - 1) = recvdatastr(i - 1) + Chr$(datafield1(i - 1))
                    recvstate(i - 1) = 128 + 5
                Case 2: '2 bytes and end of message
                    recvdatastr(i - 1) = recvdatastr(i - 1) + Chr$(datafield1(i - 1)) + Chr$(datafield2(i - 1))
                    recvstate(i - 1) = 128 + 5
                Case 3: '3 bytes and end of message
                    recvdatastr(i - 1) = recvdatastr(i - 1) + Chr$(datafield1(i - 1)) + Chr$(datafield2(i - 1)) + Chr$(datafield3(i - 1))
                    recvstate(i - 1) = 128 + 5
                Case 4: '4 bytes and end of message
                    recvdatastr(i - 1) = recvdatastr(i - 1) + Chr$(datafield1(i - 1)) + Chr$(datafield2(i - 1)) + Chr$(datafield3(i - 1)) + Chr$(datafield4(i - 1))
                    recvstate(i - 1) = 128 + 5
                Case &H88: 'Frame Error
                    Add_Text PortNum(i - 1), "RX: Frame Error during Reception (9-11 bit frame)."
                    If RecvError = True Then
                        StopRepeat
                    End If
                    swallowcount(i - 1) = 2
                    recvstate(i - 1) = 0
                    recvcks(i - 1) = 0
                Case &HFF: '4 bytes and continuation
                    recvdatastr(i - 1) = recvdatastr(i - 1) + Chr$(datafield1(i - 1)) + Chr$(datafield2(i - 1)) + Chr$(datafield3(i - 1)) + Chr$(datafield4(i - 1))
                    recvstate(i - 1) = 128 + 7
                Case Else:
                    Add_Text PortNum(i - 1), "Received illegal length indicator " + Hex$(RecvChar)
                    If ReceiveBufferOverflowOccurred(i - 1) = True Then
                        Add_Text PortNum(i - 1), "(BUT THAT IS PROBABLY BECAUSE THE SERIAL RECEIVE BUFFER OVERFLOWED)"
                    End If
                    If ClearBufferOccurred(i - 1) = True Then
                        Add_Text PortNum(i - 1), "(BUT THAT IS BECAUSE CLEAR BUFFERS OPERATION IS IN EFFECT AND BUFFER MAY HAVE BEEN CLEARED IN MIDDLE)"
                    End If
                    If RecvError = True Then
                        StopRepeat
                    End If
                    recvstate(i - 1) = 0
                    recvcks(i - 1) = 0
            End Select
        Case Else:
            MsgBox "Illegal recvstate(" + Format(i - 1, "#0") + ")=" + Format(recvstate(i - 1), "#0")
            recvstate(i - 1) = 0
            recvcks(i - 1) = 0
            If RecvError = True Then
                StopRepeat
            End If
    End Select
End If
End Sub

Public Sub Update_Cks(i As Integer, val As Integer)
recvcks(i - 1) = recvcks(i - 1) + val
If recvcks(i - 1) >= 256 Then recvcks(i - 1) = recvcks(i - 1) - 256
End Sub

Public Sub Add_Text(COMportnum As Integer, sStr As String)
Dim pos As Long
inAddText = True
If logging = True Then
    On Error GoTo badsave
    logfilesize = logfilesize + 9 + Len(Time$) + Len(sStr)
    Print #2, Time$ + " COM" + Format(COMportnum, "#0") + ": " + sStr
    GoTo donewithsave
badsave:
    On Error Resume Next
    MsgBox "Error Saving to Log File!  Saved " + Format(logfilesize, "#0") + " bytes already.", vbCritical, "Error"
    On Error GoTo badclose
    Close #2
    GoTo donewithsave
badclose:
    On Error Resume Next
    MsgBox "Error closing Log File!", vbCritical, "Error"
    GoTo donewithsave
donewithsave:
End If
On Error GoTo noroom
If Len(fTop.tTerminalWindow.Text) + Len(sStr) + Len(Time$) + 9 + 2 > fTop.tTerminalWindow.MaxLength Then
    GoTo noroom
End If
fTop.tTerminalWindow.Text = fTop.tTerminalWindow.Text + Time$ + " COM" + Format(COMportnum, "#0") + ": " + sStr + Chr$(13) + Chr$(10)
fTop.tTerminalWindow.SelStart = Len(fTop.tTerminalWindow.Text)
On Error Resume Next
inAddText = False
Exit Sub
noroom:
pos = Len(fTop.tTerminalWindow.Text) / 8
If pos <= Len(fTop.tTerminalWindow.Text) Then
    fTop.tTerminalWindow.Text = Right$(fTop.tTerminalWindow.Text, (Len(fTop.tTerminalWindow.Text) - pos) + 1)
    fTop.tTerminalWindow.Text = fTop.tTerminalWindow.Text + Time$ + " COM" + Format(COMportnum, "#0") + ": " + sStr + Chr$(13) + Chr$(10)
Else
    fTop.tTerminalWindow.Text = Time$ + " COM" + Format(COMportnum, "#0") + ": " + sStr + Chr$(13) + Chr$(10)
End If
fTop.tTerminalWindow.SelStart = Len(fTop.tTerminalWindow.Text)
On Error Resume Next
inAddText = False
End Sub

Public Sub StopRepeat()
Dim i As Integer
If Repeat_ID <> 0 Then
    Repeat_ID = 0
    If Repeat_ID2 <> 0 Then
        Repeat_ID2 = 0
        fTop.bRepeat.Caption = "Send Selected Messages Repeatedly"
    Else
        fTop.bRepeat.Caption = "Send Selected Message Repeatedly"
    End If
    For i = 0 To 15
        RecvMismatchInit(i) = False
    Next i
    fTop.bRepeat.Enabled = True
End If
End Sub

Public Sub DisplayErrorCode(nodeidx As Integer)
Dim i As Integer
i = PortNum(nodeidx)
Select Case ErrorCode
    Case &H0: Add_Text i, "RX: Bit Error (Failed to assert LIN line low)."
    Case &H1: Add_Text i, "RX: Identifier Parity Error during Reception."
    Case &H2: Add_Text i, "RX: Inconsistent Synch Field during Reception."
    Case &H3: Add_Text i, "RX: Frame Error during Reception (9-11 bit frame)."
    Case &H4: Add_Text i, "RX: Lost Arbitration (Failed to set LIN line high or lost arbitration or bus shorted to ground)."
    Case &H5: Add_Text i, "RX: Received Illegal Data while LIN Bus Was Asleep."
    Case &H6: Add_Text i, "RX: Slave not responding."
    Case &H20: Add_Text i, "RX: Received invalid checksum from PC."
    Case &H21: Add_Text i, "RX: Received invalid command from PC."
    Case &H22: Add_Text i, "RX: Command not acceptable in fast repeat mode."
    Case &H30: Add_Text i, "RX: Receive (from PC to LIN box) buffer overflow."
    Case &H31: Add_Text i, "RX: Transmit (from LIN box to PC) buffer overflow."
    Case &H4F: Add_Text i, "RX: LIN Box status OK."
    Case &H50: Add_Text i, "RX: LIN Bus Transmit Overflow (from PC to LIN bus)."
    Case &H51: Add_Text i, "RX: LIN Bus Receive Overflow (from LIN bus to PC)."
    Case &HE0: Add_Text i, "RX: FLASH ROM Checksum Error."
    Case &HFF: Add_Text i, "RX: Error communicating with LIN box."
    Case Else: Add_Text i, "RX: LIN Box returned error code " + Hex$(ErrorCode) + "H"
End Select
End Sub


Public Function Elapsed(TimeStamp As Integer)
Dim TimeElapsed As Integer
If (TimeStamp > HundredMsec) Then
    TimeElapsed = (32767 - TimeStamp) + HundredMsec
Else
    TimeElapsed = HundredMsec - TimeStamp
End If
Elapsed = TimeElapsed
End Function
