Option Strict Off
Option Explicit On
Friend Class fAddNode
	Inherits System.Windows.Forms.Form
    Private Sub Add_COMport()
        Dim i As Short
        If Number_of_Ports < 16 Then
            If GetPort(Number_of_Ports).IsOpen() = True Then
                GetPort(Number_of_Ports).Close()
            End If
        Else
            MsgBox("Can only have up to 16 active ports!")
            Me.Close()
            Exit Sub
        End If
        On Error GoTo notgood
        GetPort(Number_of_Ports).PortName = lbCOM.SelectedItem
        If GetPort(Number_of_Ports).IsOpen() = True Then
            GetPort(Number_of_Ports).Close()
        End If
        GetPort(Number_of_Ports).BaudRate = 38400
        GetPort(Number_of_Ports).RtsEnable = True
        GetPort(Number_of_Ports).DtrEnable = False
        GetPort(Number_of_Ports).Encoding = System.Text.Encoding.Default()
        GetPort(Number_of_Ports).Handshake = IO.Ports.Handshake.RequestToSend
        GetPort(Number_of_Ports).Open()
        GetPort(Number_of_Ports).DiscardInBuffer()
        PortNum(Number_of_Ports) = Val(Mid$(lbCOM.SelectedItem, 4))
        Number_of_Ports = Number_of_Ports + 1
        lbCOM.BackColor = System.Drawing.ColorTranslator.FromOle(RGB(255, 255, 255))
        If Loaded Then SaveData()
        fTop.tNodeList.Text = ""
        For i = 1 To Number_of_Ports
            fTop.tNodeList.Text = fTop.tNodeList.Text & VB6.Format(i, "#0") & ": COM" & VB6.Format(PortNum(i - 1), "#0") & Chr(13) & Chr(10)
        Next i
        Me.Close()
        Exit Sub
notgood:
        On Error Resume Next
        lbCOM.BackColor = System.Drawing.ColorTranslator.FromOle(RGB(255, 0, 0))
        MessageBox.Show("Could not open port " + lbCOM.SelectedItem + "!")
    End Sub
	
    Private Sub fAddNode_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim i As Integer
        Dim j As Integer
        lbCOM.Items.Clear()
        j = 0
        For i = 0 To 255
            If goodport(i) = True Then
                j = j + 1
                lbCOM.Items.Add("COM" + VB6.Format(i, "#0"))
                If PortNum(Number_of_Ports) = i Then
                    lbCOM.SelectedIndex = j - 1
                End If
            End If
        Next
        If GetPort(Number_of_Ports).IsOpen() = True Then
            lbCOM.BackColor = System.Drawing.ColorTranslator.FromOle(RGB(255, 255, 255))
        Else
            lbCOM.BackColor = System.Drawing.ColorTranslator.FromOle(RGB(255, 0, 0))
        End If
    End Sub
    Private Sub lbCOM_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lbCOM.SelectedIndexChanged
        On Error GoTo notgood
        If GetPort(Number_of_Ports).IsOpen = True Then
            GetPort(Number_of_Ports).Close()
        End If
        On Error GoTo notgood
        GetPort(Number_of_Ports).PortName = lbCOM.Items(lbCOM.SelectedIndex)
        lbCOM.BackColor = System.Drawing.ColorTranslator.FromOle(RGB(255, 0, 0))
        If Loaded Then SaveData()
        Exit Sub
notgood:
        On Error Resume Next
        lbCOM.BackColor = System.Drawing.ColorTranslator.FromOle(RGB(255, 0, 0))
    End Sub

    Private Sub bAdd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bAdd.Click
        Add_COMport()
    End Sub
End Class