Option Strict Off
Option Explicit On
Friend Class fConfigure
	Inherits System.Windows.Forms.Form
	'UPGRADE_WARNING: Event cBadCheck.CheckStateChanged may fire when form is initialized. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub cBadCheck_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cBadCheck.CheckStateChanged
		BadChecksum = cBadCheck.CheckState
		SaveData()
	End Sub
	
	'UPGRADE_WARNING: Event cEnableWakeup.CheckStateChanged may fire when form is initialized. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub cEnableWakeup_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cEnableWakeup.CheckStateChanged
		wakeupenabled = cEnableWakeup.CheckState
		If wakeupenabled = True Then
			Label3.Enabled = True
			cWakeup.Enabled = True
			'Label3.ForeColor = &H800000
			If fTop.Visible = True Then
				fTop.bWakeup.Enabled = True
			End If
		Else
			Label3.Enabled = False
			cWakeup.Enabled = False
			'Label3.ForeColor = &H200000
			If fTop.Visible = True Then
				fTop.bWakeup.Enabled = False
			End If
		End If
		SaveData()
		SendSettings = True 'added 2.0
	End Sub
	
	
	'UPGRADE_WARNING: Event cExtendedWakeup.CheckStateChanged may fire when form is initialized. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub cExtendedWakeup_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cExtendedWakeup.CheckStateChanged
		ExtendedWakeup = cExtendedWakeup.CheckState
		SaveData()
		SendSettings = True
	End Sub
	
	'UPGRADE_WARNING: Event cLin20.CheckStateChanged may fire when form is initialized. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub cLin20_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cLin20.CheckStateChanged
		LIN20 = cLin20.CheckState
		SaveData()
		SendSettings = True
	End Sub
	
	'UPGRADE_WARNING: Event cMismatchErr.CheckStateChanged may fire when form is initialized. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub cMismatchErr_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cMismatchErr.CheckStateChanged
		MismatchError = cMismatchErr.CheckState
		SaveData()
	End Sub
	
	'UPGRADE_WARNING: Event cNoResp.CheckStateChanged may fire when form is initialized. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub cNoResp_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cNoResp.CheckStateChanged
		NoResponse = cNoResp.CheckState
		SaveData()
	End Sub
	
	'Private Sub cQuick_Click()
	'If cQuick.Value > 0 Then
	'    quicker = True
	'    fTop.Timer1.Interval = 10
	'Else
	'    quicker = False
	'    fTop.Timer1.Interval = 100
	'End If
	'SaveData
	'End Sub
	
	'UPGRADE_WARNING: Event cRecvErr.CheckStateChanged may fire when form is initialized. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub cRecvErr_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cRecvErr.CheckStateChanged
		RecvError = cRecvErr.CheckState
		SaveData()
	End Sub
	
	'UPGRADE_WARNING: Event cRep2.CheckStateChanged may fire when form is initialized. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub cRep2_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cRep2.CheckStateChanged
        Repeat2 = cRep2.CheckState
		If Repeat2 = False Then
			If Repeat_ID2 <> 0 Then
				Repeat_ID2 = 0
				If Repeat_ID = 0 Then
                    fTop.bRepeat.Text = "Send Selected Messages Repeatedly"
				Else
                    fTop.bRepeat.Text = "Stop Sending Selected Message"
				End If
			End If
		End If
		SaveData()
	End Sub
	
	'UPGRADE_WARNING: Event cSlave.CheckStateChanged may fire when form is initialized. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub cSlave_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cSlave.CheckStateChanged
		If cSlave.CheckState = 1 Then
			SlaveMode = True
		Else
			SlaveMode = False
		End If
		SendSettings = True
		SaveData()
	End Sub
	
	Private Sub fConfigure_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
		If SlaveMode = True Then
			cSlave.CheckState = System.Windows.Forms.CheckState.Checked
		Else
			cSlave.CheckState = System.Windows.Forms.CheckState.Unchecked
		End If
		If ExtendedWakeup = True Then
			cExtendedWakeup.CheckState = System.Windows.Forms.CheckState.Checked
		Else
			cExtendedWakeup.CheckState = System.Windows.Forms.CheckState.Unchecked
		End If
		If MismatchError = True Then
			cMismatchErr.CheckState = System.Windows.Forms.CheckState.Checked
		Else
			cMismatchErr.CheckState = System.Windows.Forms.CheckState.Unchecked
		End If
		If RecvError = True Then
			cRecvErr.CheckState = System.Windows.Forms.CheckState.Checked
		Else
			cRecvErr.CheckState = System.Windows.Forms.CheckState.Unchecked
		End If
		If WakeupMode = True Then
			cWakeup.CheckState = System.Windows.Forms.CheckState.Checked
		Else
			cWakeup.CheckState = System.Windows.Forms.CheckState.Unchecked
		End If
		If BadChecksum = True Then
			cBadCheck.CheckState = System.Windows.Forms.CheckState.Checked
		Else
			cBadCheck.CheckState = System.Windows.Forms.CheckState.Unchecked
		End If
		If NoResponse = True Then
			cNoResp.CheckState = System.Windows.Forms.CheckState.Checked
		Else
			cNoResp.CheckState = System.Windows.Forms.CheckState.Unchecked
		End If
		If Repeat2 = True Then
			cRep2.CheckState = System.Windows.Forms.CheckState.Checked
		Else
			cRep2.CheckState = System.Windows.Forms.CheckState.Unchecked
		End If
		'If quicker = True Then
		'    cQuick.Value = 1
		'Else
		'    cQuick.Value = 0
		'End If
		If LIN20 = True Then
			cLin20.CheckState = System.Windows.Forms.CheckState.Checked
		Else
			cLin20.CheckState = System.Windows.Forms.CheckState.Unchecked
		End If
		If wakeupenabled = True Then
			cEnableWakeup.CheckState = System.Windows.Forms.CheckState.Checked
			Label3.Enabled = True
			'Label3.ForeColor = &H800000
			cWakeup.Enabled = True
			If fTop.Visible = True Then
				fTop.bWakeup.Enabled = True
			End If
		Else
			cEnableWakeup.CheckState = System.Windows.Forms.CheckState.Unchecked
			Label3.Enabled = False
			'Label3.ForeColor = &H200000
			cWakeup.Enabled = False
			If fTop.Visible = True Then
				fTop.bWakeup.Enabled = False
			End If
		End If
        tBaud.Text = VB6.Format(BaudRate, "#0")
        tFastRepeat.Text = VB6.Format(FastRepeatInterval, "#0")
	End Sub
	
	'Private Sub cSlave_Click()
	'If cSlave.Value = 1 Then
	'    SlaveMode = True
	'Else
	'    SlaveMode = False
	'End If
	'SendSettings = True
	'SaveData
	'End Sub
	
	'UPGRADE_WARNING: Event cWakeup.CheckStateChanged may fire when form is initialized. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub cWakeup_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cWakeup.CheckStateChanged
		If cWakeup.CheckState = 1 Then
			WakeupMode = True
		Else
			WakeupMode = False
		End If
		SendSettings = True
		SaveData()
	End Sub
	
	
	'UPGRADE_WARNING: Event tBaud.TextChanged may fire when form is initialized. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub tBaud_TextChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles tBaud.TextChanged
        Try
            BaudRate = Val(tBaud.Text)
            If BaudRate > MAX_BAUD Or BaudRate < MIN_BAUD Then
                tBaud.BackColor = System.Drawing.ColorTranslator.FromOle(RGB(255, 0, 0))
            Else
                tBaud.BackColor = System.Drawing.ColorTranslator.FromOle(RGB(255, 255, 255))
                SaveData()
                SendSettings = True
            End If
        Catch
            tBaud.BackColor = System.Drawing.ColorTranslator.FromOle(RGB(255, 0, 0))
        End Try
    End Sub

    Private Sub tFastRepeat_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tFastRepeat.TextChanged
        Try
            FastRepeatInterval = Val(tFastRepeat.Text)
            If (FastRepeatInterval < 0) Or (FastRepeatInterval > 5000) Then
                tFastRepeat.BackColor = System.Drawing.ColorTranslator.FromOle(RGB(255, 0, 0))
            Else
                tFastRepeat.BackColor = System.Drawing.ColorTranslator.FromOle(RGB(255, 255, 255))
                SaveData()
                SendSettings = True
            End If
        Catch
            tFastRepeat.BackColor = System.Drawing.ColorTranslator.FromOle(RGB(255, 0, 0))
        End Try
    End Sub
End Class