Option Strict Off
Option Explicit On
Friend Class fMsgWindow
	Inherits System.Windows.Forms.Form
	Private Sub Command1_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Command1.Click
		Selected_Message = Number_of_Messages + 1
		SaveData()
		VB6.ShowForm(fAddMsg, VB6.FormShowConstants.Modal, Me)
		fAddMsg.Close()
		fMsgWindow_Load(Me, New System.EventArgs())
	End Sub
	
	Private Sub Command2_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Command2.Click
        Dim sStr As String = ""
		Dim Message_Number As Short
		Dim result As MsgBoxResult
		If Selected_Message < 1 Then
			MsgBox("No selected message!")
			Exit Sub
		End If
		If Selected_Message > Number_of_Messages Then
			MsgBox("Illegal selected message!")
			Exit Sub
		End If
		result = MsgBox("Are you sure you want to delete message" & Str(Selected_Message) & "?", MsgBoxStyle.YesNoCancel, "Confirm Delete Message")
		If result <> MsgBoxResult.Yes Then Exit Sub
		On Error GoTo errread
		FileOpen(1, My.Application.Info.DirectoryPath & "\LIN.MSG", OpenMode.Input)
		On Error GoTo errwrite
		FileOpen(3, My.Application.Info.DirectoryPath & "\LIN.TMP", OpenMode.Output)
		Message_Number = 1
		While Not EOF(1)
			Input(1, sStr)
			If Message_Number <> Selected_Message Then
				PrintLine(3, sStr)
			End If
			Message_Number = Message_Number + 1
		End While
		FileClose(3)
		FileClose(1)
		On Error GoTo errread2
		FileOpen(1, My.Application.Info.DirectoryPath & "\LIN.TMP", OpenMode.Input)
		On Error GoTo errwrite2
		FileOpen(3, My.Application.Info.DirectoryPath & "\LIN.MSG", OpenMode.Output)
		While Not EOF(1)
			Input(1, sStr)
			PrintLine(3, sStr)
		End While
		FileClose(1)
		FileClose(3)
		On Error Resume Next
        If Selected_Message >= Number_of_Messages Then
            Selected_Message = 0
            SaveData()
        End If
		fMsgWindow_Load(Me, New System.EventArgs())
		Exit Sub
errread: 
		MsgBox("Error reading from " & My.Application.Info.DirectoryPath & "\LIN.MSG!")
		Exit Sub
errwrite: 
		MsgBox("Error writing to " & My.Application.Info.DirectoryPath & "\LIN.TMP!")
		On Error GoTo dontclose1
		FileClose(1)
dontclose1: 
		On Error GoTo dontclose2
		FileClose(3)
dontclose2: 
		On Error Resume Next
		Exit Sub
errread2: 
		MsgBox("Error reading from " & My.Application.Info.DirectoryPath & "\LIN.TMP!")
		Exit Sub
errwrite2: 
		MsgBox("Error writing to " & My.Application.Info.DirectoryPath & "\LIN.MSG!")
		On Error GoTo dontclose3
		FileClose(1)
dontclose3: 
		On Error GoTo dontclose4
		FileClose(3)
dontclose4: 
		On Error Resume Next
		Exit Sub
	End Sub
	
	Private Sub Command3_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Command3.Click
		If Selected_Message < 1 Then
			MsgBox("No selected message!")
			Exit Sub
		End If
		If Selected_Message > Number_of_Messages Then
			MsgBox("Illegal selected message!")
			Exit Sub
		End If
		VB6.ShowForm(fAddMsg, VB6.FormShowConstants.Modal, Me)
		fAddMsg.Close()
		fMsgWindow_Load(Me, New System.EventArgs())
	End Sub
	
	Private Sub fMsgWindow_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
		Dim i As Short
        Dim sStr As String = ""
		On Error GoTo nomsgs
		FileOpen(1, My.Application.Info.DirectoryPath & "\LIN.MSG", OpenMode.Input)
		On Error GoTo donemsgs
		For Number_of_Messages = 1 To 1000
			If EOF(1) Then GoTo donemsgs
			Input(1, sStr)
		Next Number_of_Messages
		MsgBox(My.Application.Info.DirectoryPath & "\LIN.MSG has more than 1000 msgs!  We only have memory for 1000.")
		GoTo donemsgs
nomsgs: 
		On Error Resume Next
		lMsgAvail.Text = "0"
		Number_of_Messages = 0
		Exit Sub
donemsgs: 
		On Error Resume Next
		FileClose(1)
		Text1.Text = ""
		Number_of_Messages = Number_of_Messages - 1
		lMsgAvail.Text = VB6.Format(Number_of_Messages, "#0")
		'Selected_Message = 1
		On Error GoTo errread
		FileOpen(1, My.Application.Info.DirectoryPath & "\LIN.MSG", OpenMode.Input)
		For i = 1 To Number_of_Messages
			Input(1, sStr)
			Text1.Text = Text1.Text & "Message" & Str(i) & ": " & sStr & Chr(13) & Chr(10)
		Next i
		FileClose(1)
		On Error Resume Next
		Text2.Text = VB6.Format(Selected_Message, "#0")
		Exit Sub
errread: 
		MsgBox("Error reading " & My.Application.Info.DirectoryPath & "\LIN.MSG!")
		FileClose(1)
		Text2.Text = VB6.Format(Selected_Message, "#0")
	End Sub
	
	Private Sub Text1_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Text1.Click
		Dim x As Short
		Dim line As Short
		Dim pos As Integer
		x = Text1.SelectionStart
		line = 1
		If Len(Text1.Text) > 0 Then
			For pos = 1 To Len(Text1.Text)
				If pos = x Then GoTo donepos
				If Mid(Text1.Text, pos, 1) = Chr(13) Then
					line = line + 1
				End If
			Next pos
		Else
			line = 0
		End If
donepos: 
		If line > 0 Then
			Text2.Text = VB6.Format(line, "#0")
		End If
	End Sub
	
	'UPGRADE_WARNING: Event Text2.TextChanged may fire when form is initialized. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub Text2_TextChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Text2.TextChanged
		Dim pos As Integer
		Dim line As Short
		On Error GoTo badval
		If Val(Text2.Text) < 1 Or Val(Text2.Text) > Number_of_Messages Then
			If Text2.Text = "" Then
				Selected_Message = 0
				SaveData()
badsel: Text2.BackColor = System.Drawing.ColorTranslator.FromOle(RGB(255, 0, 0))
			Else
				Text2.Text = "1"
				Selected_Message = 1
				SaveData()
				On Error Resume Next
				GoTo selmsg
			End If
			On Error Resume Next
			Exit Sub
		End If
		On Error Resume Next
		Selected_Message = Val(Text2.Text)
		SaveData()
selmsg: 
		Text2.BackColor = System.Drawing.ColorTranslator.FromOle(RGB(255, 255, 255))
		pos = 0
		line = 1
		While line <> Selected_Message
			If pos < Len(Text1.Text) Then
				pos = pos + 1
				If Mid(Text1.Text, pos, 1) = Chr(13) Then
					line = line + 1
				End If
			Else
				GoTo badsel
			End If
		End While
		Text1.SelectionStart = pos
		While line = Selected_Message
			If pos < Len(Text1.Text) Then
				pos = pos + 1
				If Mid(Text1.Text, pos, 1) = Chr(13) Then
					line = line + 1
				End If
			Else
				GoTo donesel
			End If
		End While
donesel: 
		Text1.SelectionLength = pos - Text1.SelectionStart
		Exit Sub
badval: 
		On Error Resume Next
		Text2.Text = "1"
		Selected_Message = 1
		SaveData()
		Text2.BackColor = System.Drawing.ColorTranslator.FromOle(RGB(255, 255, 255))
	End Sub
End Class