Option Strict Off
Option Explicit On
Imports VB = Microsoft.VisualBasic
Friend Class fTop
	Inherits System.Windows.Forms.Form
	Const Repeat_Duration As Short = 1 '0.1 second (units 100 msec)
	Const Repeat_Duration2 As Short = 2 '0.2 second
	
	Public NextXmit As Short
	Public XmitLen As Short
	Public SubCode As Short
	Public SendQuery As Boolean
	Public In_Message_Send As Boolean
	Public SendHeader As String
	Public RespRecvd As Boolean
	Dim Repeat_Name_String As String
	Dim Repeat_Name_String2 As String
	Dim Repeat_String As String
	Dim Repeat_String2 As String
	Dim RepeatStamp As Short
	Dim RepeatStamp2 As Short
	Dim pos As Integer
	Dim lline As Short
	Dim TimeStamp As Short
	Dim PendingAckStamp As Short
	
	'UPGRADE_WARNING: Form event fTop.Activate has a new behavior. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="6BA9B8D2-2A32-4B6E-8D36-44949974A5B4"'
	Private Sub fTop_Activated(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Activated
		If wakeupenabled = True Then
			bWakeup.Enabled = True
		Else
			bWakeup.Enabled = False
		End If
	End Sub
	
	Private Sub fTop_FormClosed(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
		If logging = True Then
            FileClose(2)
        End If
        Quit = True
    End Sub
	
	Private Sub bStartLogging_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles bStartLogging.Click
		If logging = False Then
            On Error GoTo cancelled
			CDSave.Title = "Select Log File to Save As"
			CDSave.ShowDialog()
			On Error GoTo badfile
			logfilesize = 0
			FileOpen(2, CDSave.FileName, OpenMode.Output)
			logging = True
			Exit Sub
badfile: 
			On Error Resume Next
			MsgBox("Could not open " & CDSave.FileName & " for writing!", MsgBoxStyle.Critical, "Error")
			CDSave.FileName = ""
			Exit Sub
cancelled: 
			On Error Resume Next
			MsgBox("Logging cancelled.")
			Exit Sub
		Else
			MsgBox("Logging has already been started using log file " & CDSave.FileName, MsgBoxStyle.Information, "Notice")
		End If
	End Sub
	Private Sub bStopLogging_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles bStopLogging.Click
		If logging = False Then
			MsgBox("Logging has not been started yet!", MsgBoxStyle.Exclamation, "Error")
		Else
			On Error GoTo badclose
			FileClose(2)
			logging = False
			MsgBox("Log file size " & VB6.Format(logfilesize, "#0") & " saved to " & CDSave.FileName, MsgBoxStyle.Information, "Log File Saved")
			Exit Sub
badclose: 
			On Error Resume Next
			MsgBox("Could not close " & CDSave.FileName, MsgBoxStyle.Critical, "Error")
			Exit Sub
		End If
	End Sub
	Private Sub bAddNode_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles bAddNode.Click
		fAddNode.Show()
	End Sub
	
	Private Sub bConfigure_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles bConfigure.Click
		fConfigure.Show()
	End Sub
	
	Private Sub bEditMsg_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles bEditMsg.Click
		fMsgWindow.Show()
	End Sub
	
	Private Sub bQuery_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles bQuery.Click
		If Number_of_Ports > 0 Then
			SendQuery = True
		Else
			MsgBox("No nodes to query!")
		End If
	End Sub
	
	Private Sub bRemoveNode_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles bRemoveNode.Click
		Dim i As Short
        Dim result As MsgBoxResult
		If SelectedNode < 1 Then
			MsgBox("No selected node!")
			Exit Sub
		End If
		If SelectedNode > Number_of_Ports Then
			MsgBox("Illegal selected node!")
			Exit Sub
		End If
		result = MsgBox("Are you sure you want to delete node" & Str(SelectedNode) & " (COM" & VB6.Format(PortNum(SelectedNode - 1), "#0") & ")?", MsgBoxStyle.YesNoCancel, "Confirm Delete Message")
		If result <> MsgBoxResult.Yes Then Exit Sub
		For i = SelectedNode + 1 To Number_of_Ports
			PortNum(i - 1) = PortNum(i)
		Next i
		Number_of_Ports = Number_of_Ports - 1
		SaveData()
		tNodeList.Text = ""
		For i = 1 To Number_of_Ports
			tNodeList.Text = tNodeList.Text & VB6.Format(i, "#0") & ": COM" & VB6.Format(PortNum(i - 1), "#0") & Chr(13) & Chr(10)
		Next i
		SelectedNode = 1
		If Number_of_Ports > 0 Then
			Select_Node()
		End If
	End Sub
	
	Private Sub bRepeat_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles bRepeat.Click
		Dim ID As Short
		Dim i As Short
        Dim sStr As String = ""
		bRepeat.Enabled = False
		If Repeat_ID <> 0 Then
			Repeat_ID = 0
			If Repeat_ID2 <> 0 Then
				Repeat_ID2 = 0
				bRepeat.Text = "Send Selected Message(s) Repeatedly"
			Else
				bRepeat.Text = "Send Selected Message Repeatedly"
			End If
			bRepeat.Enabled = True
			Exit Sub
		End If
		If Number_of_Ports = 0 Then
			MsgBox("No nodes to send messages on!")
			bRepeat.Enabled = True
			Exit Sub
		End If
		If SelectedNode = 0 Then
			MsgBox("No node selected!")
			bRepeat.Enabled = True
			Exit Sub
		End If
		If SelectedNode > Number_of_Ports Then
			MsgBox("Illegal selected node!")
			bRepeat.Enabled = True
			Exit Sub
		End If
		If MismatchError = True Then
			Repeat_ID = 1
			Repeat_ID2 = 0
			RepeatStamp = HundredMsec
			GoTo start_repeating
		End If
		If Selected_Message < 1 Then
			MsgBox("No message selected.")
			bRepeat.Enabled = True
			Exit Sub
		End If
		On Error GoTo errread
		FileOpen(1, My.Application.Info.DirectoryPath & "\LIN.MSG", OpenMode.Input)
		On Error GoTo notthere
		For i = 1 To Selected_Message
			Input(1, sStr)
		Next i
		FileClose(1)
		On Error Resume Next
		If Len(sStr) < 2 Then
			MsgBox("Messages must have at least 1 byte of data.")
			bSendMsg.Enabled = True
			bRepeat.Enabled = True
			Exit Sub
		End If
		HexToChar((VB.Left(sStr, 2)))
		ID = HexNum
		If ID > &H3Fs Then
			MsgBox("The 1st byte of the message is the ID.  ID's must have the 2 most signficant bits set to 0.  The LIN Box automatically calculates the parity bits that get put there.")
			bSendMsg.Enabled = True
			bRepeat.Enabled = True
			Exit Sub
		End If
		Repeat_ID = ID + 1
		Repeat_Name_String = sStr
		Repeat_String = ""
		For i = 4 To Len(sStr) Step 3
			HexToChar((Mid(sStr, i, 2)))
			Repeat_String = Repeat_String & Chr(HexNum)
		Next i
		RepeatStamp = HundredMsec
		If Selected_Message > 1 And Repeat2 = True Then
			On Error GoTo errread
			FileOpen(1, My.Application.Info.DirectoryPath & "\LIN.MSG", OpenMode.Input)
			On Error GoTo notthere
			For i = 1 To Selected_Message - 1
				Input(1, sStr)
			Next i
			FileClose(1)
			On Error Resume Next
			If Len(sStr) < 2 Then
				Repeat_ID2 = 0
			Else
				HexToChar((VB.Left(sStr, 2)))
				ID = HexNum
				If ID > &H3Fs Then
					Repeat_ID2 = 0
				Else
					Repeat_ID2 = ID + 1
					Repeat_Name_String2 = sStr
					Repeat_String2 = ""
					For i = 4 To Len(sStr) Step 3
						HexToChar((Mid(sStr, i, 2)))
						Repeat_String2 = Repeat_String2 & Chr(HexNum)
					Next i
					RepeatStamp2 = HundredMsec
				End If
			End If
		End If
start_repeating: 
		If Repeat_ID2 <> 0 Then
			bRepeat.Text = "Stop Sending Repeat Messages"
		Else
			bRepeat.Text = "Stop Sending Repeat Message"
		End If
		bRepeat.Enabled = True
		Exit Sub
errread: 
		On Error Resume Next
		MsgBox("Error reading " & My.Application.Info.DirectoryPath & "\LIN.MSG!")
		FileClose(1)
		bSendMsg.Enabled = True
		bRepeat.Enabled = True
		Exit Sub
notthere: 
		On Error Resume Next
		MsgBox("Undefined selected message!")
		FileClose(1)
		bSendMsg.Enabled = True
		bRepeat.Enabled = True
	End Sub
	
	Private Sub bSendMsg_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles bSendMsg.Click
		Dim ID As Short
		Dim i As Short
        Dim sStr As String = ""
		Dim sStr2 As String
		If Number_of_Ports = 0 Then
			MsgBox("No nodes to send messages on!")
			Exit Sub
		End If
		If SelectedNode = 0 Then
			MsgBox("No node selected!")
			Exit Sub
		End If
		If SelectedNode > Number_of_Ports Then
			MsgBox("Illegal selected node!")
			Exit Sub
		End If
		If Selected_Message < 1 Then
			MsgBox("No message selected.")
			Exit Sub
		End If
		bSendMsg.Enabled = False
		On Error GoTo errread
		FileOpen(1, My.Application.Info.DirectoryPath & "\LIN.MSG", OpenMode.Input)
		On Error GoTo notthere
		For i = 1 To Selected_Message
			Input(1, sStr)
		Next i
		FileClose(1)
		On Error Resume Next
		If Len(sStr) < 2 Then
			MsgBox("Messages must have at least 1 byte of data.")
			bSendMsg.Enabled = True
			Exit Sub
		End If
		HexToChar((VB.Left(sStr, 2)))
		ID = HexNum
		If ID > &H3Fs Then
			MsgBox("The 1st byte of the message is the ID.  ID's must have the 2 most signficant bits set to 0.  The LIN Box automatically calculates the parity bits that get put there.")
			bSendMsg.Enabled = True
			Exit Sub
		End If
		sStr2 = ""
		For i = 4 To Len(sStr) Step 3
			HexToChar((Mid(sStr, i, 2)))
			sStr2 = sStr2 & Chr(HexNum)
		Next i
		On Error GoTo comportclosed
        If GetPort(SelectedNode - 1).CtsHolding = True Then
sm:         Add_Text(PortNum(SelectedNode - 1), "TX: Message " & sStr)
            Send_Message(SelectedNode - 1, ID, sStr2)
        Else
            TimeStamp = HundredMsec
            System.Windows.Forms.Application.DoEvents()
            While (Elapsed(TimeStamp) < 20)
                If GetPort(SelectedNode - 1).CtsHolding = True Then
                    GoTo sm
                End If
                System.Windows.Forms.Application.DoEvents()
            End While
            Add_Text(PortNum(SelectedNode - 1), "LIN Box is not connected!")
        End If
		bSendMsg.Enabled = True
		Exit Sub
comportclosed: 
		On Error Resume Next
		Add_Text(PortNum(SelectedNode - 1), "Trouble accessing COM port")
		Exit Sub
errread: 
		On Error Resume Next
		MsgBox("Error reading " & My.Application.Info.DirectoryPath & "\LIN.MSG!")
		FileClose(1)
		bSendMsg.Enabled = True
		Exit Sub
notthere: 
		On Error Resume Next
		MsgBox("Undefined selected message!")
		FileClose(1)
		bSendMsg.Enabled = True
	End Sub
	
	Private Sub bWakeup_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles bWakeup.Click
		If wakeupenabled = False Then
			bWakeup.Enabled = False
			MsgBox("Wake-ups are not enabled!", MsgBoxStyle.Exclamation, "Error")
			Exit Sub
		End If
		If Number_of_Ports = 0 Then
			MsgBox("No nodes to send wakeups on!")
			Exit Sub
		End If
		If SelectedNode = 0 Then
			MsgBox("No node selected!")
			Exit Sub
		End If
		If SelectedNode > Number_of_Ports Then
			MsgBox("Illegal selected node!")
			Exit Sub
		End If
		On Error GoTo comportclosed
		If Quit = False Then
            If GetPort(SelectedNode - 1).CtsHolding = True Then
wp:             Add_Text(PortNum(SelectedNode - 1), "TX: Wakeup Signal")
                Send_Message(SelectedNode - 1, SEND_WAKEUP_SIGNAL, "")
            Else
                TimeStamp = HundredMsec
                System.Windows.Forms.Application.DoEvents()
                While (Elapsed(TimeStamp) < 20)
                    If GetPort(SelectedNode - 1).CtsHolding = True Then
                        GoTo wp
                    End If
                    System.Windows.Forms.Application.DoEvents()
                End While
                Add_Text(PortNum(SelectedNode - 1), "LIN Box is not connected!")
            End If
		End If
		On Error Resume Next
		Exit Sub
comportclosed: 
		On Error Resume Next
		Add_Text(PortNum(SelectedNode - 1), "Trouble accessing COM port")
	End Sub
	Private Sub Select_Node()
		pos = 1
		lline = 1
		While lline <> SelectedNode
			If pos < Len(tNodeList.Text) Then
				pos = pos + 1
				If Mid(tNodeList.Text, pos, 1) = Chr(13) Then
					lline = lline + 1
				End If
			Else
				GoTo badsel
			End If
		End While
		tNodeList.SelectionStart = pos
		While lline = SelectedNode
			If pos < Len(tNodeList.Text) Then
				pos = pos + 1
				If Mid(tNodeList.Text, pos, 1) = Chr(13) Then
					lline = lline + 1
				End If
			Else
				GoTo donesel
			End If
		End While
donesel: 
		tNodeList.SelectionLength = pos - tNodeList.SelectionStart
		Exit Sub
badsel: 
badval: 
		On Error Resume Next
		SelectedNode = 1
		If Number_of_Ports >= 1 And Quit = False Then
			Select_Node()
		End If
	End Sub
	
	Private Sub bClear_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles bClear.Click
		If Number_of_Ports = 0 Then
			MsgBox("No nodes to clear buffers on!")
			Exit Sub
		End If
		If SelectedNode = 0 Then
			MsgBox("No node selected!")
			Exit Sub
		End If
		If SelectedNode > Number_of_Ports Then
			MsgBox("Illegal selected node!")
			Exit Sub
		End If
		On Error GoTo comportclosed
		If Waiting = False And Quit = False Then
			Add_Text(PortNum(SelectedNode - 1), "TX: Clear Receive Buffer")
            If GetPort(SelectedNode - 1).CtsHolding = True Then
crb:            ClearBufferOccurred(SelectedNode - 1) = True
                ClearBufferTimestamp(SelectedNode - 1) = HundredMsec
                Send_Message(SelectedNode - 1, CLEAR_RECEIVE_BUFFER, "")
                ClearBufferOccurred(SelectedNode - 1) = True
                ClearBufferTimestamp(SelectedNode - 1) = HundredMsec
            Else
                TimeStamp = HundredMsec
                System.Windows.Forms.Application.DoEvents()
                While (Elapsed(TimeStamp) < 20)
                    If GetPort(SelectedNode - 1).CtsHolding = True Then
                        GoTo crb
                    End If
                    System.Windows.Forms.Application.DoEvents()
                End While
                Add_Text(PortNum(SelectedNode - 1), "LIN Box is not connected!")
            End If
		End If
		On Error Resume Next
		Exit Sub
comportclosed: 
		On Error Resume Next
		Add_Text(PortNum(SelectedNode - 1), "Error accessing COM port.")
	End Sub

    Private Sub SeekPorts()
        Dim i As Integer
        For i = 0 To 255
            Try
                If GetPort(0).IsOpen = True Then
                    GetPort(0).Close()
                End If
                GetPort(0).PortName = "COM" + VB6.Format(i, "#")
                GetPort(0).Open()
                GetPort(0).Close()
                goodport(i) = True
            Catch
                goodport(i) = False
            End Try
        Next i

    End Sub

	'Private Sub comPort_OnComm(Index As Integer)
	'recvstr(Index) = recvstr(Index) + comPort(Index).Input
	'End Sub
	
	Private Sub fTop_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
        Dim i As Short
        Dim j As Short
		Dim sStr2 As String
		If Quit = True Then
			Exit Sub
		End If
		in_background = False
		Me.Hide()
		'UPGRADE_ISSUE: App property App.PrevInstance was not upgraded. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="076C26E5-B7A9-4E77-B69C-B4448DF39E58"'
        'If App.PrevInstance Then
        'MsgBox("Already Running")
        'Quit = True
        'Exit Sub
        'End If
        inAddText = False
        SendQuery = False
        logging = False
        LIN20 = False
        ExtendedWakeup = False
        SlaveMode = False
        For i = 0 To 15
            RecvMismatchInit(i) = False
            swallowcount(i) = 0
        Next i
        TimeVal = 2
        frmSplash.Show()
        Loaded = False
        Repeat_ID = 0
        Repeat_ID2 = 0
        SendHeader = "LINCB"
        tTerminalWindow.Text = ""
        SeekPorts()
        On Error GoTo nodata
        FileOpen(1, My.Application.Info.DirectoryPath & "\LIN.CFG", OpenMode.Input)
        On Error GoTo baddata
        Input(1, sStr)
        SelectedNode = Val(sStr)
        Input(1, sStr)
        Selected_Message = Val(sStr)
        Input(1, sStr)
        BaudRate = Val(sStr)
        If BaudRate > MAX_BAUD Then
            BaudRate = 9600
        End If
        If BaudRate < MIN_BAUD Then
            BaudRate = 9600
        End If
        Input(1, sStr)
        If Val(sStr) >= 1 Then
            BadChecksum = True
        Else
            BadChecksum = False
        End If
        Input(1, sStr)
        If Val(sStr) >= 1 Then
            WakeupMode = True
        Else
            WakeupMode = False
        End If
        Input(1, sStr)
        If Val(sStr) >= 1 Then
            NoResponse = True
        Else
            NoResponse = False
        End If
        Input(1, sStr)
        If Val(sStr) >= 1 Then
            Repeat2 = True
        Else
            Repeat2 = False
        End If
        Input(1, sStr)
        Number_of_Ports = Val(sStr)
        For i = 1 To Number_of_Ports
            Input(1, sStr)
            PortNum(i - 1) = Val(sStr)
        Next i
        On Error GoTo baddata2
        Input(1, sStr)
        If Val(sStr) >= 1 Then
            MismatchError = True
        Else
            MismatchError = False
        End If
        Input(1, sStr)
        If Val(sStr) >= 1 Then
            RecvError = True
        Else
            RecvError = False
        End If
        'Input #1, sStr
        'If val(sStr) >= 1 Then
        '    quicker = True
        'Else
        '    quicker = False
        'End If
        Input(1, sStr)
        If Val(sStr) >= 1 Then
            wakeupenabled = True
            bWakeup.Enabled = True
        Else
            wakeupenabled = False
            bWakeup.Enabled = False
        End If
        Input(1, sStr)
        If Val(sStr) >= 1 Then
            LIN20 = True
        Else
            LIN20 = False
        End If
        Input(1, sStr)
        If Val(sStr) >= 1 Then
            ExtendedWakeup = True
        Else
            ExtendedWakeup = False
        End If
        Input(1, sStr)
        If Val(sStr) >= 1 Then
            SlaveMode = True
        Else
            SlaveMode = False
        End If
        Input(1, sStr)
        FastRepeatInterval = Val(sStr)
        If FastRepeatInterval > 5000 Then
            FastRepeatInterval = 5000
        End If
        If FastRepeatInterval < 0 Then
            FastRepeatInterval = 0
        End If
        FileClose(1)
        SendSettings = True
backtomain:
        On Error Resume Next
        Loaded = True
        SelectedNode = 1
        'On Error GoTo badcomm
        tNodeList.Text = ""
        On Error GoTo comportclosed
        For i = 1 To 16
            If GetPort(i - 1).IsOpen() = True Then
                GetPort(i - 1).Close()
            End If
            If i <= Number_of_Ports Then
                GetPort(i - 1).PortName = "COM" + VB6.Format(PortNum(i - 1), "#")
            End If
        Next i
        For i = 1 To Number_of_Ports
            recvstr(i - 1) = ""
            recvstate(i - 1) = 0
            recvcks(i - 1) = 0
            tNodeList.Text = tNodeList.Text & VB6.Format(i, "#0") & ": COM" & VB6.Format(PortNum(i - 1), "#0") & Chr(13) & Chr(10)
            If GetPort(i - 1).IsOpen() = True Then
                GetPort(i - 1).Close()
            End If
            GetPort(i - 1).BaudRate = 38400
            GetPort(i - 1).Handshake = IO.Ports.Handshake.RequestToSend
            GetPort(i - 1).RtsEnable = True
            GetPort(i - 1).DtrEnable = False
            GetPort(i - 1).Encoding = System.Text.Encoding.Default()
            GetPort(i - 1).Open()
            'sStr = comPort(i - 1).Input 'clear rx buf
            GetPort(i - 1).DiscardInBuffer()
        Next i
        Select_Node()
sendit0:
        For i = 1 To Number_of_Ports
            On Error GoTo comportclosed
            If GetPort(i - 1).CtsHolding = True Then
sendit:         System.Windows.Forms.Application.DoEvents()
                System.Windows.Forms.Application.DoEvents()
                System.Windows.Forms.Application.DoEvents()
                System.Windows.Forms.Application.DoEvents()
                System.Windows.Forms.Application.DoEvents()
                Ack_Received = 0
                Add_Text(PortNum(i - 1), "TX: Query Revision")
                On Error GoTo comportclosed
                Send_Message(i - 1, QUERY_REVISION, "")
                TimeStamp = HundredMsec
                While (Ack_Received <> QUERY_REVISION) And (Quit = False) And (Elapsed(TimeStamp) < 30)
                    System.Windows.Forms.Application.DoEvents()
                    RecvBackgroundTask()
                End While
                Add_Text(PortNum(i - 1), "TX: Query Status")
                Send_Message(i - 1, QUERY_STATUS, "")
                TimeStamp = HundredMsec
                While (Ack_Received <> QUERY_STATUS) And (Quit = False) And (Elapsed(TimeStamp) < 30)
                    System.Windows.Forms.Application.DoEvents()
                    RecvBackgroundTask()
                End While
            Else
                TimeStamp = HundredMsec
                System.Windows.Forms.Application.DoEvents()
                While (Elapsed(TimeStamp) < 20)
                    If GetPort(i - 1).CtsHolding = True Then
                        GoTo sendit
                    End If
                    System.Windows.Forms.Application.DoEvents()
                End While
                Add_Text(PortNum(i - 1), "LIN Box is not connected!")
                SendQuery = False
            End If
        Next i
keepgoing:
        On Error Resume Next
        While TimeVal > 0 And Quit = False
            System.Windows.Forms.Application.DoEvents()
            RecvBackgroundTask()
        End While
        If Quit = False Then
            Me.Show()
            System.Windows.Forms.Application.DoEvents()
            System.Windows.Forms.Application.DoEvents()
            System.Windows.Forms.Application.DoEvents()
            Select_Node()
        End If
        While Quit = False
            System.Windows.Forms.Application.DoEvents()
            RecvBackgroundTask()
            If SendQuery = True Then
                SendQuery = False
                GoTo sendit0
            End If
            System.Windows.Forms.Application.DoEvents()
            If SendSettings = True Then
                SendSettings = False
                For i = 1 To Number_of_Ports
                    System.Windows.Forms.Application.DoEvents()
sendbr:             On Error GoTo comportclosed
                    If Quit = True Then GoTo exitthis
                    If GetPort(i - 1).CtsHolding = True Then
                        sStr = Chr(Int(BaudRate / 256)) & Chr(BaudRate And 255)
                        Add_Text(PortNum(i - 1), "TX: Set LIN Bus Baud Rate to" & Str(BaudRate))
                        Send_Message(i - 1, SET_LIN_BUS_BAUD_RATE, sStr)
                        TimeStamp = HundredMsec
                        While Ack_Received <> SET_LIN_BUS_BAUD_RATE And Quit = False And Elapsed(TimeStamp) < 30
                            System.Windows.Forms.Application.DoEvents()
                            RecvBackgroundTask()
                        End While
                    Else
                        While (Elapsed(TimeStamp) < 20)
                            If GetPort(i - 1).CtsHolding = True Then
                                GoTo sendbr
                            End If
                            System.Windows.Forms.Application.DoEvents()
                        End While
                        Add_Text(PortNum(i - 1), "LIN Box is not connected!")
                    End If
sendwp:             If Quit = True Then GoTo exitthis
                    On Error GoTo comportclosed
                    If GetPort(i - 1).CtsHolding = True Then
                        If WakeupMode = True Then
                            sStr = Chr(1)
                        Else
                            sStr = Chr(0)
                        End If
                        Add_Text(PortNum(i - 1), "TX: Set Continuous Wakeup to " & Chr(Asc(sStr) + 48))
                        Send_Message(i - 1, SET_WAKEUP_PENDING, sStr)
                        TimeStamp = HundredMsec
                        While Ack_Received <> SET_WAKEUP_PENDING And Quit = False And Elapsed(TimeStamp) < 30
                            System.Windows.Forms.Application.DoEvents()
                            RecvBackgroundTask()
                        End While
                    Else
                        While (Elapsed(TimeStamp < 20))
                            If GetPort(i - 1).CtsHolding = True Then
                                GoTo sendwp
                            End If
                            System.Windows.Forms.Application.DoEvents()
                        End While
                        Add_Text(PortNum(i - 1), "LIN Box is not connected!")
                    End If
sendwe:             If Quit = True Then GoTo exitthis
                    On Error GoTo comportclosed
                    If GetPort(i - 1).CtsHolding = True Then
                        If wakeupenabled = True Then
                            sStr = Chr(1)
                        Else
                            sStr = Chr(0)
                        End If
                        Add_Text(PortNum(i - 1), "TX: Set Wakeup Enable to " & Chr(Asc(sStr) + 48))
                        Send_Message(i - 1, SET_WAKEUPS_ENABLED, sStr)
                        TimeStamp = HundredMsec
                        While Ack_Received <> SET_WAKEUPS_ENABLED And Quit = False And Elapsed(TimeStamp) < 30
                            System.Windows.Forms.Application.DoEvents()
                            RecvBackgroundTask()
                        End While
                    Else
                        While (Elapsed(TimeStamp) < 20)
                            If GetPort(i - 1).CtsHolding = True Then
                                GoTo sendwe
                            End If
                            System.Windows.Forms.Application.DoEvents()
                        End While
                        Add_Text(PortNum(i - 1), "LIN Box is not connected!")
                    End If
sendpr:             If Quit = True Then GoTo exitthis
                    On Error GoTo comportclosed
                    If GetPort(i - 1).CtsHolding = True Then
                        If LIN20 = True Then
                            sStr = Chr(1)
                            sStr2 = "2.0"
                        Else
                            sStr = Chr(0)
                            sStr2 = "1.3"
                        End If
                        Add_Text(PortNum(i - 1), "TX: Set LIN Protocol to " & sStr2)
                        Send_Message(i - 1, SET_LIN_PROTOCOL, sStr)
                        TimeStamp = HundredMsec
                        While Ack_Received <> SET_LIN_PROTOCOL And Quit = False And Elapsed(TimeStamp) < 30
                            System.Windows.Forms.Application.DoEvents()
                            RecvBackgroundTask()
                        End While
                    Else
                        While (Elapsed(TimeStamp) < 20)
                            If GetPort(i - 1).CtsHolding = True Then
                                GoTo sendwe
                            End If
                            System.Windows.Forms.Application.DoEvents()
                        End While
                        Add_Text(PortNum(i - 1), "LIN Box is not connected!")
                    End If
sendex:             If Quit = True Then GoTo exitthis
                    On Error GoTo comportclosed
                    If GetPort(i - 1).CtsHolding = True Then
                        If ExtendedWakeup = True Then
                            sStr = Chr(1)
                            sStr2 = "Enabled"
                        Else
                            sStr = Chr(0)
                            sStr2 = "Disabled"
                        End If
                        Add_Text(PortNum(i - 1), "TX: Set Extended Wakeups to " & sStr2)
                        Send_Message(i - 1, SET_EXTENDED_WAKEUP, sStr)
                        TimeStamp = HundredMsec
                        While Ack_Received <> SET_EXTENDED_WAKEUP And Quit = False And Elapsed(TimeStamp) < 30
                            System.Windows.Forms.Application.DoEvents()
                            RecvBackgroundTask()
                        End While
                    Else
                        While (Elapsed(TimeStamp) < 20)
                            If GetPort(i - 1).CtsHolding = True Then
                                GoTo sendwe
                            End If
                            System.Windows.Forms.Application.DoEvents()
                        End While
                        Add_Text(PortNum(i - 1), "LIN Box is not connected!")
                    End If
sendmm:             If Quit = True Then GoTo exitthis
                    On Error GoTo comportclosed
                    If GetPort(i - 1).CtsHolding = True Then
                        If SlaveMode = True Then
                            sStr = Chr(0)
                            sStr2 = "Slave/Listener Mode"
                        Else
                            sStr = Chr(1)
                            sStr2 = "Master Mode"
                        End If
                        Add_Text(PortNum(i - 1), "TX: Set Mode to " & sStr2)
                        Send_Message(i - 1, SET_MASTER_SLAVE_MODE, sStr)
                        TimeStamp = HundredMsec
                        While Ack_Received <> SET_MASTER_SLAVE_MODE And Quit = False And Elapsed(TimeStamp) < 30
                            System.Windows.Forms.Application.DoEvents()
                            RecvBackgroundTask()
                        End While
                    Else
                        While (Elapsed(TimeStamp) < 20)
                            If GetPort(i - 1).CtsHolding = True Then
                                GoTo sendwe
                            End If
                            System.Windows.Forms.Application.DoEvents()
                        End While
                        Add_Text(PortNum(i - 1), "LIN Box is not connected!")
                    End If
sendfi:             On Error GoTo comportclosed
                    If Quit = True Then GoTo exitthis
                    If GetPort(i - 1).CtsHolding = True Then
                        sStr = Chr(Int(FastRepeatInterval / 256)) & Chr(FastRepeatInterval And 255)
                        Add_Text(PortNum(i - 1), "TX: Set Fast Repeat Interval to" & Str(FastRepeatInterval))
                        Send_Message(i - 1, SET_FAST_REPEAT_INTERVAL, sStr)
                        TimeStamp = HundredMsec
                        While Ack_Received <> SET_FAST_REPEAT_INTERVAL And Quit = False And Elapsed(TimeStamp) < 30
                            System.Windows.Forms.Application.DoEvents()
                            RecvBackgroundTask()
                        End While
                    Else
                        While (Elapsed(TimeStamp) < 20)
                            If GetPort(i - 1).CtsHolding = True Then
                                GoTo sendbr
                            End If
                            System.Windows.Forms.Application.DoEvents()
                        End While
                        Add_Text(PortNum(i - 1), "LIN Box is not connected!")
                    End If
                Next i
            End If
        End While
exitthis:
        On Error Resume Next
        End
        Exit Sub
comportclosed:
        On Error Resume Next
        Add_Text(PortNum(i - 1), "Trouble accessing COM port.")
        SendQuery = False
        SendSettings = False
        GoTo keepgoing
nodata:
        On Error Resume Next
        Selected_Message = 1
        Loaded = True
        GoTo backtomain
baddata2:
        On Error Resume Next
        FileClose(1)
        Loaded = True
        GoTo backtomain
baddata:
        On Error Resume Next
        FileClose(1)
        MsgBox("Bad data found in file " & My.Application.Info.DirectoryPath & "\LIN.CFG.")
        Selected_Message = 1
        Loaded = True
        GoTo backtomain
badcomm:
        On Error Resume Next
        MsgBox("Could not initialize COM" & VB6.Format(PortNum(i - 1), "#0"))
        For j = i To Number_of_Ports - 1
            PortNum(j - 1) = PortNum(j)
        Next j
        Number_of_Ports = Number_of_Ports - 1
        If Number_of_Ports > 0 Then GoTo backtomain
        tNodeList.Text = ""
        GoTo sendit0
    End Sub
	
	'UPGRADE_WARNING: Event fTop.Resize may fire when form is initialized. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub fTop_Resize(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Resize
		If VB6.PixelsToTwipsY(Me.Height) >= 4635 Then
			Frame2.Height = VB6.TwipsToPixelsY(VB6.PixelsToTwipsY(Me.Height) - 1740)
			tTerminalWindow.Height = VB6.TwipsToPixelsY(VB6.PixelsToTwipsY(Me.Height) - 2100)
		End If
		If VB6.PixelsToTwipsX(Me.Width) >= 6870 Then
			Frame2.Width = VB6.TwipsToPixelsX(VB6.PixelsToTwipsX(Me.Width) - 3255)
			tTerminalWindow.Width = VB6.TwipsToPixelsX(VB6.PixelsToTwipsX(Me.Width) - 3495)
		End If
	End Sub
	
	'UPGRADE_NOTE: Form_Terminate was upgraded to Form_Terminate_Renamed. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="A9E4979A-37FA-4718-9994-97DD76ED70A7"'
	'UPGRADE_WARNING: fTop event Form.Terminate has a new behavior. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="6BA9B8D2-2A32-4B6E-8D36-44949974A5B4"'
	Private Sub Form_Terminate_Renamed()
		Quit = True
	End Sub
	
	
	Private Sub Timer1_Tick(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Timer1.Tick
		Dim i As Short
		Dim j As Short
		Dim count As Short
		Dim sStr As String
		Dim sStr2 As String
		On Error GoTo comportclosed
		If HundredMsec < 32767 Then
			HundredMsec = HundredMsec + 1
		Else
			RepeatStamp2 = 0
			RepeatStamp = 0
			TimeStamp = 0
			HundredMsec = 0
		End If
        If WaitPendingAck = True And (Elapsed(PendingAckStamp) >= 1200) Then
            WaitPendingAck = False
            NextXmit = PendingAck
            If NextXmit > 0 Then
                NextXmit = NextXmit - 1
            Else
                NextXmit = &H3FS
            End If
        End If
        		If Repeat_ID > 0 And (Elapsed(RepeatStamp) >= Repeat_Duration) And MismatchError = True And WaitPendingAck = False Then
            If In_Message_Send = False Then
                RepeatStamp = HundredMsec
                If NextXmit >= &H3FS Then
                    NextXmit = 0
                Else
                    NextXmit = NextXmit + 1
                End If
                i = NextXmit
                PendingAck = NextXmit
                WaitPendingAck = True
                PendingAckStamp = HundredMsec
                If XmitLen < 1 Then
                    XmitLen = 1
                Else
                    If XmitLen >= 8 Then
                        XmitLen = 1
                    Else
                        XmitLen = XmitLen + 1
                    End If
                End If
                sStr = ""
                sStr2 = Hexx(i)
                For j = 1 To XmitLen
                    If NextXmit >= &H3FS Then
                        NextXmit = 0
                    Else
                        NextXmit = NextXmit + 1
                    End If
                    sStr = sStr & Chr(NextXmit)
                    sStr2 = sStr2 & " " & Hexx(NextXmit)
                Next j
                If GetPort(SelectedNode - 1).CtsHolding = True Then
                    Add_Text(PortNum(SelectedNode - 1), "TX: Message " & sStr2)
                    Send_Message(SelectedNode - 1, i, sStr)
                End If
            End If
        End If
        If Repeat_ID > 0 And (Elapsed(RepeatStamp) >= Repeat_Duration) And MismatchError = False Then
            If In_Message_Send = False Then
                RepeatStamp = HundredMsec
                If GetPort(SelectedNode - 1).CtsHolding = True Then
                    Add_Text(PortNum(SelectedNode - 1), "TX: Message " & Repeat_Name_String)
                    Send_Message(SelectedNode - 1, Repeat_ID - 1, Repeat_String)
                End If
            End If
        End If
        If Repeat_ID2 > 0 And (Elapsed(RepeatStamp2) >= Repeat_Duration2) And MismatchError = False Then
            If In_Message_Send = False Then
                RepeatStamp2 = HundredMsec
                If GetPort(SelectedNode - 1).CtsHolding = True Then
                    Add_Text(PortNum(SelectedNode - 1), "TX: Message " & Repeat_Name_String2)
                    Send_Message(SelectedNode - 1, Repeat_ID2 - 1, Repeat_String2)
                End If
            End If
        End If
		If Quit = True Or Loaded = False Then
			Exit Sub
		End If
		count = 0
		For i = 1 To Number_of_Ports
            If GetPort(i - 1).IsOpen() = True And Quit = False Then
                If GetPort(i - 1).ReadBufferSize = GetPort(i - 1).BytesToRead Then
                    Add_Text(PortNum(i - 1), "PC Receive Buffer Overflow!")
                    ReceiveBufferOverflowOccurred(i - 1) = True
                End If
                If GetPort(i - 1).BytesToRead > 0 Then
                    If Len(recvstr(i - 1)) < 10000 Then
                        recvstr(i - 1) = recvstr(i - 1) + GetPort(i - 1).ReadExisting
                        count = count + 1
                        If count < 10 Then
                            System.Windows.Forms.Application.DoEvents()
                            i = 0
                        End If
                    Else
                        Add_Text(PortNum(i - 1), "PC Receive Buffer Overflow!")
                        ReceiveBufferOverflowOccurred(i - 1) = True
                    End If
                End If
            End If
		Next i
		On Error Resume Next
		Exit Sub
comportclosed: 
		On Error Resume Next
		Add_Text(PortNum(SelectedNode - 1), "Trouble accessing COM port.")
	End Sub
	Public Sub HexToChar(ByRef s As String)
		Dim i As Short
		i = Asc(VB.Left(s, 1))
		If i >= Asc("0") And i <= Asc("9") Then
			i = i - Asc("0")
		Else
			If i >= Asc("A") And i <= Asc("F") Then
				i = i - Asc("A")
				i = i + 10
			Else
				If i >= Asc("a") And i <= Asc("f") Then
					i = i - Asc("a")
					i = i + 10
				End If
			End If
		End If
		HexNum = i * 16
		i = Asc(VB.Right(s, 1))
		If i >= Asc("0") And i <= Asc("9") Then
			i = i - Asc("0")
		Else
			If i >= Asc("A") And i <= Asc("F") Then
				i = i - Asc("A")
				i = i + 10
			Else
				If i >= Asc("a") And i <= Asc("f") Then
					i = i - Asc("a")
					i = i + 10
				End If
			End If
		End If
		HexNum = HexNum + i
	End Sub
	
	Public Sub Send_Message(ByRef portidx As Short, ByRef ID As Short, ByRef DataField As String)
		Dim i As Short
		Dim x As Short
		Dim TimeStamp As Short
		In_Message_Send = True
		On Error GoTo comportclosed
		x = 0 'x will be PC-LIN Box Checksum
		'Waiting = True
		For i = 1 To Len(SendHeader)
			x = x + Asc(Mid(SendHeader, i, 1))
			If x >= 256 Then x = x - 256
		Next i
        GetPort(portidx).Write(SendHeader)
		While ID >= 256 : ID = ID - 256 : End While
		x = x + ID
		If x >= 256 Then x = x - 256
		For i = 0 To 500
			System.Windows.Forms.Application.DoEvents()
		Next 
        GetPort(portidx).Write(Chr(ID))
		For i = 0 To 100
			System.Windows.Forms.Application.DoEvents()
		Next 
		If ID < &H40s Then
			i = Len(DataField)
			x = x + (Int(i / 256))
			If (x >= 256) Then x = x - 256
			x = x + CShort(i And 255)
			If (x >= 256) Then x = x - 256
            GetPort(portidx).Write(Chr(Int(i / 256)) & Chr(i And 255))
		End If
		For i = 1 To Len(DataField)
			x = x + Asc(Mid(DataField, i, 1))
			If x >= 256 Then x = x - 256
		Next i
		If (Len(DataField) > 0) Then
			For i = 0 To 100
				System.Windows.Forms.Application.DoEvents()
			Next 
            GetPort(portidx).Write(DataField)
			For i = 0 To 100 * (Len(DataField) - 1)
				System.Windows.Forms.Application.DoEvents()
			Next 
		End If
		'debug: Add_Text PortNum(portidx), "cks = " + Str$(x)
		For i = 0 To 100
			System.Windows.Forms.Application.DoEvents()
		Next 
        GetPort(portidx).Write(Chr(x) & Chr(255 - x))
		In_Message_Send = False
		On Error Resume Next
		Exit Sub
comportclosed: 
		On Error Resume Next
		Add_Text(PortNum(portidx), "Trouble accessing COM port.")
	End Sub
	
	Private Sub tNodeList_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles tNodeList.Click
		Dim x As Integer
		Dim lline As Short
		Dim pos As Integer
		x = tNodeList.SelectionStart
		lline = 1
		If Len(tNodeList.Text) > 0 Then
			For pos = 1 To Len(tNodeList.Text)
				If pos = x Then GoTo donepos
				If Mid(tNodeList.Text, pos, 1) = Chr(13) Then
					lline = lline + 1
				End If
			Next pos
		Else
			lline = 0
		End If
donepos: 
		SelectedNode = lline
		If lline > 0 Then
			Select_Node()
		End If
	End Sub

    Private Sub bFastRepeat_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bFastRepeat.Click
        If Number_of_Ports = 0 Then
            MsgBox("No nodes to fast repeat on!")
            Exit Sub
        End If
        If SelectedNode = 0 Then
            MsgBox("No node selected!")
            Exit Sub
        End If
        If SelectedNode > Number_of_Ports Then
            MsgBox("Illegal selected node!")
            Exit Sub
        End If
        On Error GoTo comportclosed
        If Quit = False Then
            If GetPort(SelectedNode - 1).CtsHolding = True Then
frm:            Add_Text(PortNum(SelectedNode - 1), "TX: Set Fast Repeat Mode")
                Send_Message(SelectedNode - 1, SET_FAST_REPEAT_MODE, "")
            Else
                TimeStamp = HundredMsec
                System.Windows.Forms.Application.DoEvents()
                While (Elapsed(TimeStamp) < 20)
                    If GetPort(SelectedNode - 1).CtsHolding = True Then
                        GoTo frm
                    End If
                    System.Windows.Forms.Application.DoEvents()
                End While
                Add_Text(PortNum(SelectedNode - 1), "LIN Box is not connected!")
            End If
        End If
        On Error Resume Next
        Exit Sub
comportclosed:
        On Error Resume Next
        Add_Text(PortNum(SelectedNode - 1), "Trouble accessing COM port")
    End Sub
End Class