VERSION 5.00
Begin VB.Form fMsgWindow 
   Caption         =   "Message Edit Window"
   ClientHeight    =   4950
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6150
   Icon            =   "fMsgWindow.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   4950
   ScaleWidth      =   6150
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command3 
      Caption         =   "Edit Selected Message"
      Height          =   615
      Left            =   4080
      TabIndex        =   7
      Top             =   4320
      Width           =   1215
   End
   Begin VB.CommandButton Command2 
      Caption         =   "Delete Selected Message"
      Height          =   615
      Left            =   2280
      TabIndex        =   6
      Top             =   4320
      Width           =   1095
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Add Message"
      Height          =   615
      Left            =   480
      TabIndex        =   5
      Top             =   4320
      Width           =   1095
   End
   Begin VB.TextBox Text2 
      Alignment       =   2  'Center
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   420
      Left            =   4440
      TabIndex        =   2
      Top             =   600
      Width           =   975
   End
   Begin VB.TextBox Text1 
      Height          =   2775
      HideSelection   =   0   'False
      Left            =   120
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Top             =   1320
      Width           =   5895
   End
   Begin VB.Label lMsgAvail 
      Alignment       =   2  'Center
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   4320
      TabIndex        =   4
      Top             =   120
      Width           =   1215
   End
   Begin VB.Label Label2 
      Caption         =   "Number of Messages Available:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   240
      TabIndex        =   3
      Top             =   120
      Width           =   3615
   End
   Begin VB.Label lSelMsgTxt 
      Caption         =   "Selected Message Number:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   240
      TabIndex        =   1
      Top             =   720
      Width           =   3135
   End
End
Attribute VB_Name = "fMsgWindow"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Sub Command1_Click()
Selected_Message = Number_of_Messages + 1
SaveData
fAddMsg.Show vbModal, Me
Unload fAddMsg
Form_Load
End Sub

Private Sub Command2_Click()
Dim sStr As String
Dim Message_Number As Integer
Dim result As VbMsgBoxResult
If Selected_Message < 1 Then
    MsgBox "No selected message!"
    Exit Sub
End If
If Selected_Message > Number_of_Messages Then
    MsgBox "Illegal selected message!"
    Exit Sub
End If
result = MsgBox("Are you sure you want to delete message" + Str$(Selected_Message) + "?", vbYesNoCancel, "Confirm Delete Message")
If result <> vbYes Then Exit Sub
On Error GoTo errread
Open App.Path + "\LIN.MSG" For Input As #1
On Error GoTo errwrite
Open App.Path + "\LIN.TMP" For Output As #3
Message_Number = 1
While Not EOF(1)
    Input #1, sStr
    If Message_Number <> Selected_Message Then
        Print #3, sStr
    End If
    Message_Number = Message_Number + 1
Wend
Close #3
Close #1
On Error GoTo errread2
Open App.Path + "\LIN.TMP" For Input As #1
On Error GoTo errwrite2
Open App.Path + "\LIN.MSG" For Output As #3
While Not EOF(1)
    Input #1, sStr
    Print #3, sStr
Wend
Close #1
Close #3
On Error Resume Next
If Selected_Message = Tester_Present_Message Then
    Tester_Present_Message = 0
Else
    If Selected_Message < Tester_Present_Message Then
        Tester_Present_Message = Tester_Present_Message - 1
    End If
End If
If Selected_Message >= Number_of_Messages Then
    Selected_Message = 0
    SaveData
End If
Form_Load
Exit Sub
errread:
    MsgBox "Error reading from " + App.Path + "\LIN.MSG!"
    Exit Sub
errwrite:
    MsgBox "Error writing to " + App.Path + "\LIN.TMP!"
    On Error GoTo dontclose1
    Close #1
dontclose1:
    On Error GoTo dontclose2
    Close #3
dontclose2:
    On Error Resume Next
    Exit Sub
errread2:
    MsgBox "Error reading from " + App.Path + "\LIN.TMP!"
    Exit Sub
errwrite2:
    MsgBox "Error writing to " + App.Path + "\LIN.MSG!"
    On Error GoTo dontclose3
    Close #1
dontclose3:
    On Error GoTo dontclose4
    Close #3
dontclose4:
    On Error Resume Next
    Exit Sub
End Sub

Private Sub Command3_Click()
If Selected_Message < 1 Then
    MsgBox "No selected message!"
    Exit Sub
End If
If Selected_Message > Number_of_Messages Then
    MsgBox "Illegal selected message!"
    Exit Sub
End If
fAddMsg.Show vbModal, Me
Unload fAddMsg
Form_Load
End Sub

Private Sub Form_Load()
Dim i As Integer
Dim sStr As String
On Error GoTo nomsgs
Open App.Path + "\LIN.MSG" For Input As #1
On Error GoTo donemsgs
For Number_of_Messages = 1 To 1000
    If EOF(1) Then GoTo donemsgs
    Input #1, sStr
Next Number_of_Messages
MsgBox App.Path + "\LIN.MSG has more than 1000 msgs!  We only have memory for 1000."
GoTo donemsgs
nomsgs:
On Error Resume Next
lMsgAvail = "0"
Number_of_Messages = 0
Exit Sub
donemsgs:
On Error Resume Next
Close #1
Text1.Text = ""
Number_of_Messages = Number_of_Messages - 1
lMsgAvail = Format(Number_of_Messages, "#0")
'Selected_Message = 1
On Error GoTo errread
Open App.Path + "\LIN.MSG" For Input As #1
For i = 1 To Number_of_Messages
    Input #1, sStr
    Text1.Text = Text1.Text + "Message" + Str$(i) + ": " + sStr + Chr$(13) + Chr$(10)
Next i
Close #1
On Error Resume Next
Text2.Text = Format(Selected_Message, "#0")
Exit Sub
errread:
MsgBox "Error reading " + App.Path + "\LIN.MSG!"
Close #1
Text2.Text = Format(Selected_Message, "#0")
End Sub

Private Sub Text1_Click()
Dim x As Integer
Dim line As Integer
Dim pos As Long
x = Text1.SelStart
line = 1
If Len(Text1.Text) > 0 Then
    For pos = 1 To Len(Text1.Text)
        If pos = x Then GoTo donepos
        If Mid$(Text1.Text, pos, 1) = Chr$(13) Then
            line = line + 1
        End If
    Next pos
Else
    line = 0
End If
donepos:
If line > 0 Then
    Text2.Text = Format(line, "#0")
End If
End Sub

Private Sub Text2_Change()
Dim pos As Long
Dim line As Integer
On Error GoTo badval
If val(Text2.Text) < 1 Or val(Text2.Text) > Number_of_Messages Then
    If Text2.Text = "" Then
        Selected_Message = 0
        SaveData
badsel: Text2.BackColor = RGB(255, 0, 0)
    Else
        Text2.Text = "1"
        Selected_Message = 1
        SaveData
        On Error Resume Next
        GoTo selmsg
    End If
    On Error Resume Next
    Exit Sub
End If
On Error Resume Next
Selected_Message = val(Text2.Text)
SaveData
selmsg:
Text2.BackColor = RGB(255, 255, 255)
pos = 0
line = 1
While line <> Selected_Message
    If pos < Len(Text1.Text) Then
        pos = pos + 1
        If Mid$(Text1.Text, pos, 1) = Chr$(13) Then
            line = line + 1
        End If
    Else
        GoTo badsel
    End If
Wend
Text1.SelStart = pos
While line = Selected_Message
    If pos < Len(Text1.Text) Then
        pos = pos + 1
        If Mid$(Text1.Text, pos, 1) = Chr$(13) Then
            line = line + 1
        End If
    Else
        GoTo donesel
    End If
Wend
donesel:
Text1.SelLength = pos - Text1.SelStart
Exit Sub
badval:
On Error Resume Next
Text2.Text = "1"
Selected_Message = 1
SaveData
Text2.BackColor = RGB(255, 255, 255)
End Sub

