Option Strict Off
Option Explicit On
Imports VB = Microsoft.VisualBasic
Friend Class fAddMsg
	Inherits System.Windows.Forms.Form
	Dim Valid As Boolean
	Dim MsgIndex As Short
	Dim InFillData As Boolean
	
	Const MAX_ON_SCREEN As Short = 9
	Const MAX_MSG_LENGTH As Short = 9
	
	Private Sub Command1_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Command1.Click
		If Selected_Message > Number_of_Messages Then
			Selected_Message = 1
			SaveData()
		End If
		Me.Hide()
	End Sub
	
	Private Sub Command2_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Command2.Click
		Dim i As Short
        Dim sStr As String = ""
		Valid = True
		For i = 1 To Len(Message)
			If (i Mod 3) = 0 Then
				If Mid(Message, i, 1) <> " " Then
					Valid = False
					i = Len(Message)
				End If
			Else
				If i = 1 Then
					If Mid(Message, i, 1) >= "0" And Mid(Message, i, 1) <= "3" Then GoTo gotdig99
				Else
					If Mid(Message, i, 1) >= "0" And Mid(Message, i, 1) <= "9" Then GoTo gotdig99
					If Mid(Message, i, 1) >= "a" And Mid(Message, i, 1) <= "f" Then GoTo gotdig99
					If Mid(Message, i, 1) >= "A" And Mid(Message, i, 1) <= "F" Then GoTo gotdig99
				End If
				Valid = False
				i = Len(Message)
			End If
gotdig99: 
		Next i
		If Valid Then
			If Number_of_Messages > 0 Then
				On Error GoTo inputerr
				FileOpen(1, My.Application.Info.DirectoryPath & "\LIN.MSG", OpenMode.Input)
			End If
			On Error GoTo outputerr
			FileOpen(3, My.Application.Info.DirectoryPath & "\LIN.TMP", OpenMode.Output)
			On Error GoTo fileerr
			If Selected_Message > 1 And Number_of_Messages >= 1 Then
				For i = 1 To Selected_Message - 1
					Input(1, sStr)
					PrintLine(3, sStr)
				Next i
			End If
			PrintLine(3, Message)
			If Selected_Message < Number_of_Messages Then
				Input(1, sStr) 'skip message overwritten
				For i = Selected_Message + 1 To Number_of_Messages
					Input(1, sStr)
					PrintLine(3, sStr)
				Next i
			End If
			If Number_of_Messages > 0 Then
				FileClose(1)
			End If
			FileClose(3)
			If Selected_Message > Number_of_Messages Then
				Number_of_Messages = Number_of_Messages + 1
			End If
			On Error GoTo inputerr2
			FileOpen(1, My.Application.Info.DirectoryPath & "\LIN.TMP", OpenMode.Input)
			On Error GoTo outputerr2
			FileOpen(3, My.Application.Info.DirectoryPath & "\LIN.MSG", OpenMode.Output)
			While Not EOF(1)
				Input(1, sStr)
				PrintLine(3, sStr)
			End While
			FileClose(3)
			On Error GoTo inputerr2
			FileClose(1)
			On Error Resume Next
			Me.Hide()
		Else
			MsgBox("Message entered is not valid.")
		End If
		Exit Sub
inputerr2: 
		MsgBox(My.Application.Info.DirectoryPath & "\LIN.TMP could not be opened for input.")
		Exit Sub
outputerr2: 
		MsgBox("Error writing to " & My.Application.Info.DirectoryPath & "\LIN.MSG!")
		On Error GoTo dontclose2
		FileClose(3)
dontclose2: 
		On Error GoTo dontclosethen
		FileClose(1)
dontclosethen: 
		Exit Sub
inputerr: 
		MsgBox("Could not open file " & My.Application.Info.DirectoryPath & "\LIN.MSG for reading.")
		Exit Sub
outputerr: 
		If Number_of_Messages > 0 Then
			FileClose(1)
		End If
		MsgBox("Could not open file " & My.Application.Info.DirectoryPath & "\LIN.TMP for writing.")
		Exit Sub
fileerr: 
		MsgBox("File error modifying " & My.Application.Info.DirectoryPath & "\LIN.MSG.")
	End Sub
	
	Private Sub fAddMsg_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
        Dim sStr As String = ""
		Dim i As Short
		Valid = True
		InFillData = False
		For i = 1 To MAX_ON_SCREEN
			lNum(i - 1).Text = VB6.Format(i, "#0")
			tMsgData(i - 1).Text = ""
		Next i
		MsgIndex = 0
		Message = ""
		If Selected_Message <= Number_of_Messages Then
			On Error GoTo errread
			FileOpen(1, My.Application.Info.DirectoryPath & "\LIN.MSG", OpenMode.Input)
			For i = 1 To Selected_Message
				Input(1, sStr)
				System.Windows.Forms.Application.DoEvents()
			Next i
			FileClose(1)
			On Error Resume Next
			Message = sStr
			If InFillData = False Then
				FillData()
			End If
		End If
		GoTo loopread
errread: 
		On Error Resume Next
		MsgBox("Error reading " & My.Application.Info.DirectoryPath & "\LIN.MSG!")
		FileClose(1)
loopread: 
	End Sub
	
	'UPGRADE_NOTE: HScroll1.Change was changed from an event to a procedure. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="4E2DC008-5EDA-4547-8317-C9316952674F"'
	'UPGRADE_WARNING: HScrollBar event HScroll1.Change has a new behavior. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="6BA9B8D2-2A32-4B6E-8D36-44949974A5B4"'
	Private Sub HScroll1_Change(ByVal newScrollValue As Integer)
		MsgIndex = newScrollValue
		If InFillData = False Then
			FillData()
		End If
	End Sub
	'UPGRADE_WARNING: Event tMsgData.TextChanged may fire when form is initialized. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub tMsgData_TextChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles tMsgData.TextChanged
		Dim Index As Short = tMsgData.GetIndex(eventSender)
		Dim sStr As String
		If Len(tMsgData(Index).Text) < 2 Then
			GoTo digbad
		End If
		If Len(tMsgData(Index).Text) > 2 Then
			tMsgData(Index).Text = VB.Right(tMsgData(Index).Text, 2)
		End If
		If Mid(tMsgData(Index).Text, 1, 1) >= "0" And Mid(tMsgData(Index).Text, 1, 1) <= "9" Then GoTo digok1
		If Mid(tMsgData(Index).Text, 1, 1) >= "a" And Mid(tMsgData(Index).Text, 1, 1) <= "f" Then GoTo digok1
		If Mid(tMsgData(Index).Text, 1, 1) >= "A" And Mid(tMsgData(Index).Text, 1, 1) <= "F" Then GoTo digok1
		GoTo digbad
digok1: 
		If Mid(tMsgData(Index).Text, 2, 1) >= "0" And Mid(tMsgData(Index).Text, 2, 1) <= "9" Then GoTo digok2
		If Mid(tMsgData(Index).Text, 2, 1) >= "a" And Mid(tMsgData(Index).Text, 2, 1) <= "f" Then GoTo digok2
		If Mid(tMsgData(Index).Text, 2, 1) >= "A" And Mid(tMsgData(Index).Text, 2, 1) <= "F" Then GoTo digok2
		GoTo digbad
digok2: 
		tMsgData(Index).BackColor = System.Drawing.ColorTranslator.FromOle(RGB(255, 255, 255))
		While Len(Message) < (((MsgIndex + Index) * 3) + 3)
			If (Len(Message) Mod 3) = 2 Then
				Message = Message & " "
			Else
				Message = Message & "0"
			End If
		End While
		If (MsgIndex + Index) > 0 Then
			sStr = Mid(Message, 1, (MsgIndex + Index) * 3)
		Else
			sStr = ""
		End If
		If Len(tMsgData(Index).Text) < 1 Then
			sStr = sStr & "00 "
			GoTo donefillup
		End If
		If Len(tMsgData(Index).Text) < 2 Then
			GoTo fillup
		End If
		If Mid(tMsgData(Index).Text, 2, 1) = " " Then
fillup: 
			sStr = sStr & "0" & VB.Left(tMsgData(Index).Text, 1) & " "
		Else
			sStr = sStr & Mid(tMsgData(Index).Text, 1, 2) & " "
		End If
donefillup: 
		If Len(Message) > (((MsgIndex + Index) * 3) + 3) Then
			sStr = sStr & Mid(Message, ((MsgIndex + Index) * 3) + 4, Len(Message) - (((MsgIndex + Index) * 3) + 3))
		End If
		Message = sStr
		If Not InFillData Then
			FillData()
		End If
		Exit Sub
digbad: 
		tMsgData(Index).BackColor = System.Drawing.ColorTranslator.FromOle(RGB(255, 0, 0))
		Valid = False
	End Sub
	
	Private Sub tMsgData_KeyPress(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.KeyPressEventArgs) Handles tMsgData.KeyPress
		Dim KeyAscii As Short = Asc(eventArgs.KeyChar)
		Dim Index As Short = tMsgData.GetIndex(eventSender)
        Dim sStr As String
		If KeyAscii = 13 Or KeyAscii = 10 Then
			Index = Index + 1
			While Index > (MAX_ON_SCREEN - 1)
				Index = Index - 1
            End While
			HScroll1.Value = MsgIndex
			tMsgData(Index).Focus()
			FillData()
		Else
			If KeyAscii = 8 Or KeyAscii = 127 Then
				If tMsgData(Index).Text = "" Then
					tMsgData(Index).BackColor = System.Drawing.ColorTranslator.FromOle(RGB(255, 255, 255))
					If (MsgIndex + Index) > 0 Then
						Message = VB.Left(Message, (MsgIndex + Index) * 3)
					Else
						Message = ""
					End If
					While Index < (MAX_ON_SCREEN - 1)
						Index = Index + 1
						tMsgData(Index).Text = ""
						tMsgData(Index).BackColor = System.Drawing.ColorTranslator.FromOle(RGB(255, 255, 255))
					End While
				Else
					tMsgData(Index).Text = VB.Left(tMsgData(Index).Text, Len(tMsgData(Index).Text) - 1)
					If (MsgIndex + Index) > 0 Then
						sStr = Mid(Message, 1, (MsgIndex + Index) * 3)
					Else
						sStr = ""
					End If
					If Len(tMsgData(Index).Text) < 1 Then
						sStr = sStr & "00 "
						GoTo donefillup2
					End If
					If Len(tMsgData(Index).Text) < 2 Then
						GoTo fillup2
					End If
					If Mid(tMsgData(Index).Text, 2, 1) = " " Then
fillup2: 
						sStr = sStr & "0" & VB.Left(tMsgData(Index).Text, 1) & " "
					Else
						sStr = sStr & Mid(tMsgData(Index).Text, 1, 2) & " "
					End If
donefillup2: 
					If Len(Message) > (((MsgIndex + Index) * 3) + 3) Then
						sStr = sStr & Mid(Message, ((MsgIndex + Index) * 3) + 4, Len(Message) - (((MsgIndex + Index) * 3) + 3))
					End If
					Message = sStr
				End If
			End If
		End If
		eventArgs.KeyChar = Chr(KeyAscii)
		If KeyAscii = 0 Then
			eventArgs.Handled = True
		End If
	End Sub
	
	Private Sub FillData()
		Dim i As Short
		Dim j As Short
		InFillData = True
		j = 1 + (MsgIndex * 3) 'index into Message
		For i = 1 To MAX_ON_SCREEN
			lNum(i - 1).Text = CStr(MsgIndex + i)
		Next i
		For i = MsgIndex + 1 To MsgIndex + MAX_ON_SCREEN
			If Len(Message) < j Then GoTo acquired_msg
			If Mid(Message, j, 1) >= "0" And Mid(Message, j, 1) <= "9" Then GoTo gotdig1
			If Mid(Message, j, 1) >= "a" And Mid(Message, j, 1) <= "f" Then GoTo gotdig1
			If Mid(Message, j, 1) >= "A" And Mid(Message, j, 1) <= "F" Then GoTo gotdig1
			j = j + 3
			GoTo badstring
gotdig1: 
			j = j + 1
			If Len(Message) < j Then GoTo badstring2
			If Mid(Message, j, 1) >= "0" And Mid(Message, j, 1) <= "9" Then GoTo gotdig2
			If Mid(Message, j, 1) >= "a" And Mid(Message, j, 1) <= "f" Then GoTo gotdig2
			If Mid(Message, j, 1) >= "A" And Mid(Message, j, 1) <= "F" Then GoTo gotdig2
badstring2: 
			j = j + 2
			GoTo badstring
gotdig2: 
			j = j + 1
			tMsgData(i - (MsgIndex + 1)).Text = Mid(Message, j - 2, 2)
			tMsgData(i - (MsgIndex + 1)).BackColor = System.Drawing.ColorTranslator.FromOle(RGB(255, 255, 255))
			If Len(Message) < j Then
				i = i + 1
				GoTo acquired_msg
			End If
			If Mid(Message, j, 1) <> " " Then
				j = j + 1
				GoTo badstring
			End If
			j = j + 1
            GoTo resumeage
badstring:
            Valid = False
            tMsgData(i - (MsgIndex + 1)).BackColor = System.Drawing.ColorTranslator.FromOle(RGB(255, 0, 0))
            tMsgData(i - (MsgIndex + 1)).Text = ""
resumeage:
		Next i
		GoTo acquired_msg
acquired_msg:
		Valid = True
finish_msg: 
		While i <= (MsgIndex + MAX_ON_SCREEN)
			tMsgData(i - (MsgIndex + 1)).Text = ""
			tMsgData(i - (MsgIndex + 1)).BackColor = System.Drawing.ColorTranslator.FromOle(RGB(255, 255, 255))
			i = i + 1
		End While
		InFillData = False
	End Sub
	Private Sub HScroll1_Scroll(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.ScrollEventArgs) Handles HScroll1.Scroll
		Select Case eventArgs.type
			Case System.Windows.Forms.ScrollEventType.EndScroll
				HScroll1_Change(eventArgs.newValue)
		End Select
	End Sub
End Class